//***********************************************************************
//
//                              DoubleField.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;

//------------------------------------------------------------------------------
public class DoubleField extends NumberField
{
  private DecimalFormat df = (DecimalFormat)NumberFormat.getCurrencyInstance();
  private NumberFormat nf = df.getNumberInstance();
  private double prec_value;
//------------------------------------------------------------------------------
  public DoubleField() { nf.setMaximumFractionDigits(3); }
//------------------------------------------------------------------------------
  public NumberFormat NumberFormat() { return nf; }
//------------------------------------------------------------------------------
  protected boolean ValidCharacter( char c )
  {
  if( (Character.isDigit(c)) || (c==df.getDecimalFormatSymbols().getDecimalSeparator()) || (c==df.getDecimalFormatSymbols().getMinusSign()) )
    return true;
  else
    return false;
  }
//------------------------------------------------------------------------------
  public void setLocale( Locale locale )
  {
  super.setLocale(locale);
  df = (DecimalFormat)NumberFormat.getCurrencyInstance(locale);
  nf = df.getNumberInstance(locale);
  }
//------------------------------------------------------------------------------
  public void setValue(double value) { this.prec_value = value; this.setText(nf.format(value)); }
//------------------------------------------------------------------------------
  public double getValue()
  {
  try { return nf.parse(this.getText()).doubleValue(); }
  catch( ParseException e ) { this.setValue(this.prec_value); }
  return this.prec_value;
  }
}
