//***********************************************************************
//
//                              IntegerField.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;

//------------------------------------------------------------------------------
public class IntegerField extends NumberField
{
  private NumberFormat nf = NumberFormat.getInstance();
  private int prec_value;
//------------------------------------------------------------------------------
  protected boolean ValidCharacter( char c )
  {
  if( (Character.isDigit(c)) || (c == ((DecimalFormat)NumberFormat.getCurrencyInstance()).getDecimalFormatSymbols().getMinusSign()) )
    return true;
  else
    return false;
  }
//------------------------------------------------------------------------------
  public void setValue(int value) { this.prec_value = value; this.setText(nf.format(new Integer(value))); }
//------------------------------------------------------------------------------
  public int getValue()
  {
  try { return nf.parse(this.getText()).intValue(); }
  catch( ParseException e ) { this.setValue(this.prec_value); }
  return this.prec_value;
  }
}
