//***********************************************************************
//
//                              JComboBoxInputsGroup.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.util.Vector;

/*
 * Classe pour grouper des objets JComboBoxInputs pour rendre les selections exclusives entre plusieurs JComboBoxInputs
 */
public class JComboBoxInputsGroup {

    private Vector jComboBoxInputs = new Vector();

    public void add(JComboBoxInputs jcbi) {
        this.jComboBoxInputs.add(jcbi);
        jcbi.setGroup(this);
    }

    public void remove(JComboBoxInputs jcbi) {
        this.jComboBoxInputs.remove(jcbi);
        jcbi.setGroup(null);
    }

    // recherche dans les JComboBoxInputs enregistrees (sauf exclude) si index est selectionne
    public boolean isIndexAvailable(JComboBoxInputs exclude, int index) {
        for (int i = 0; i < this.jComboBoxInputs.size(); i++)
            if ((JComboBoxInputs) this.jComboBoxInputs.elementAt(i) != exclude)
                if (((JComboBoxInputs) this.jComboBoxInputs.elementAt(i)).getSelectedIndex() == index)
                    return false;
        return true;
    }
}
