//***********************************************************************
//
//                              JFISChildFrame.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.rmi.server.*;

//
//------------------------------------------------------------------------------
// Fenetres enfant d'une fenetre JFISFrame
public abstract class JFISChildFrame extends JFISDialog implements Translatable
{
protected JFISFrame parent;
private UID uid;
static Hashtable Frames = new Hashtable();
/**
 * @param owner
 * @throws HeadlessException
 */
public JFISChildFrame( JFISFrame parent, Dialog owner) throws HeadlessException {
    super(owner);
    this.init(parent);
}
//------------------------------------------------------------------------------
public JFISChildFrame( JFISFrame parent ) // constructeur temporaire
  {
    super();
    this.init(parent);
  }
private void init( JFISFrame parent ) {
    this.uid = new UID();
    JFISChildFrame.Frames.put(this.uid, this);
    this.parent = parent;
    JFISFrame.AddJFrameLook(this);
    JFISFrame.AddTranslatable(this);
    this.addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent e) { this_windowClosing(e); } });
}
//------------------------------------------------------------------------------
public boolean IsOpen() { return JFISChildFrame.Frames.get(this.uid) == null ? false: true; }
//------------------------------------------------------------------------------
public void dispose()
  {
  JFISChildFrame.Frames.remove(this.uid);
  JFISFrame.RemoveJFrameLook(this);
  JFISFrame.RemoveTranslatable(this);
  super.dispose();
  }
//------------------------------------------------------------------------------
public Point ChildPosition( Dimension child_dimension ) { return ChildPosition( this.parent, child_dimension ); }
//------------------------------------------------------------------------------
// TODO a remplacer par dialog.setLocationRelativeTo(parentComponent)
public static Point ChildPosition( Component parent, Dimension child_dimension )
  {
  int x_parent_center = parent.getX() + parent.getSize().width/2;
  int y_parent_center = parent.getY() + parent.getSize().height/2;
  int screen_width = Toolkit.getDefaultToolkit().getScreenSize().width;
  int screen_height = Toolkit.getDefaultToolkit().getScreenSize().height;
  int x_child = Math.min(x_parent_center - child_dimension.width/2, screen_width - child_dimension.width);
  x_child = Math.max(x_child, 0);
  int y_child = Math.min(y_parent_center - child_dimension.height/2, screen_height - child_dimension.height);
  y_child = Math.max(y_child, 0);
  return new Point(x_child, y_child);
  }
//------------------------------------------------------------------------------
public void this_windowClosing(WindowEvent e) { this.dispose(); }
//------------------------------------------------------------------------------
}
