//***********************************************************************
//
//                              JFISDialog.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

//------------------------------------------------------------------------------
/**
 * Redefinition de la classe JDialog pour gerer une taille minimum de la boite de dialogue\n
 * la fenetre ne peut pas etre reduite en dessous de la taille minimum.
 */

public class JFISDialog extends JDialog
{
    static private JFrame dummyFrame = new JFrame();

/**
     * @param owner
     * @throws HeadlessException
     */
    public JFISDialog(Dialog owner) throws HeadlessException {
        super(owner);
        this.init();
    }
    
    /* (non-Javadoc)
     * @see java.awt.Container#getPreferredSize()
     */
    public Dimension getPreferredSize() {
        // ajoute la hauteur du menu a la taille de la fenetre
        return new Dimension(super.getPreferredSize().width, super.getPreferredSize().height + (this.getJMenuBar() != null ? this.getJMenuBar().getPreferredSize().height : 0));
    }

/* (non-Javadoc)
     * @see java.awt.Container#getMinimumSize()
     */
    public Dimension getMinimumSize() {
        // ajoute la hauteur du menu a la taille minimum de la fenetre
        return new Dimension(super.getMinimumSize().width, super.getMinimumSize().height + (this.getJMenuBar() != null ? this.getJMenuBar().getPreferredSize().height : 0));
    }

public JFISDialog() //throws HeadlessException
  {
    super(dummyFrame);
    dummyFrame.setIconImages(MainFIS.icons);
    this.init();
  }

private void init() {
    this.addComponentListener(new ComponentAdapter()
            {
            public void componentResized(ComponentEvent e)
              {
              Dimension min_dim = JFISDialog.this.getMinimumSize();
              Dimension d = JFISDialog.this.getSize();
              if (d.height < min_dim.height || d.width < min_dim.width)
                {
                if (d.height < min_dim.height) d.height = min_dim.height;
                if (d.width < min_dim.width) d.width = min_dim.width;
                JFISDialog.this.setSize(d);
                }
              }
            });
}
//------------------------------------------------------------------------------
public void pack()
  {
  super.pack();
  Dimension screen_size = Toolkit.getDefaultToolkit().getScreenSize();
  this.setSize(new Dimension(Math.min(this.getSize().width,screen_size.width),Math.min(this.getSize().height,screen_size.height)));
  }
}
