//***********************************************************************
//
//                              JFrame2DInfer.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import org.freehep.util.export.ExportDialog;

public class JFrame2DInfer extends JFISChildFrame {

    private JPanel jContentPane = null;

    private JPanel2DInferParameters jPanel2DInferParameters = null;

    private JPanelPlot2DInfer jPanelPlot2DInfer = null;

    private JFIS fis = null;

    private JMenuBar jJMenuBar = null;

    private JMenu jMenuFile = null;

    private JMenuItem jMenuItemExport = null;

    /**
     * This is the default constructor
     */
    public JFrame2DInfer(JFISFrame parent) {
        super(parent);
        initialize();
    }

    public void show(JFIS fis) throws Throwable {
        this.fis = fis;
        this.jPanelPlot2DInfer.init(this.fis);
        this.jPanel2DInferParameters.init(this.fis, false);
        this.pack();
        // limitation de la largeur de la fenetre (a cause du jPanelPlot2DInfer qui n'est pas limite en largeur) 
        this.setSize(this.getMinimumSize().width, this.getSize().height);
        this.setLocation(JFISChildFrame.ChildPosition(this.parent, this.getSize()));
        this.setModal(true);
        super.setVisible(true);
    }

    /* (non-Javadoc)
     * @see fis.Translatable#Translate()
     */
    public void Translate() throws Throwable {
    // TODO Raccord de methode auto-genere

    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        this.setContentPane(getJContentPane());
        this.setJMenuBar(getJJMenuBar());
        this.setTitle(LocaleFIS.GetString("Section"));
    }

    /**
     * This method initializes jContentPane
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
            gridBagConstraints1.gridx = 0;
            gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints1.weightx = 1.0D;
            gridBagConstraints1.weighty = 1.0D;
            gridBagConstraints1.gridy = 1;
            GridBagConstraints gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.weightx = 1.0D;
            gridBagConstraints.gridy = 0;
            gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
            gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
            jContentPane = new JPanel();
            jContentPane.setLayout(new GridBagLayout());
            jContentPane.add(getJPanel2DInferParameters(), gridBagConstraints);
            jContentPane.add(getJPanelPlot2DInfer(), gridBagConstraints1);
        }
        return jContentPane;
    }

    /**
     * This method initializes jPanel2DInferParameters	
     * 	
     * @return fis.JPanel2DInferParameters	
     */
    private JPanel2DInferParameters getJPanel2DInferParameters() {
        if (jPanel2DInferParameters == null) {
            jPanel2DInferParameters = new JPanel2DInferParameters();
            jPanel2DInferParameters.addChangeListener(new javax.swing.event.ChangeListener() {
                public void stateChanged(javax.swing.event.ChangeEvent e) {
                    try {
                        jPanelPlot2DInfer.setOutput(fis.GetOutput(jPanel2DInferParameters.selectedOutput()));
                        jPanelPlot2DInfer.setX(fis.GetInput(jPanel2DInferParameters.selectedXInput()).GetName(), jPanel2DInferParameters.xMin(), jPanel2DInferParameters.xMax());
                        jPanelPlot2DInfer.showInferedValues(jPanel2DInferParameters.selectedXInput(), jPanel2DInferParameters.xResolution(), jPanel2DInferParameters.xMin(), jPanel2DInferParameters.xMax(), jPanel2DInferParameters.selectedOutput(), jPanel2DInferParameters.getInputsValues());
                    } catch (Throwable e1) {
                        // TODO Bloc catch auto-genere
                        e1.printStackTrace();
                    }
                }
            });
        }
        return jPanel2DInferParameters;
    }

    /**
     * This method initializes jPanelPlot2DInfer	
     * 	
     * @return fis.JPanelPlot2DInfer	
     */
    private JPanelPlot2DInfer getJPanelPlot2DInfer() {
        if (jPanelPlot2DInfer == null) {
            jPanelPlot2DInfer = new JPanelPlot2DInfer();
        }
        return jPanelPlot2DInfer;
    }

    /**
     * This method initializes jJMenuBar	
     * 	
     * @return javax.swing.JMenuBar	
     */
    private JMenuBar getJJMenuBar() {
        if (jJMenuBar == null) {
            jJMenuBar = new JMenuBar();
            jJMenuBar.add(getJMenuFile());
        }
        return jJMenuBar;
    }

    /**
     * This method initializes jMenuFile	
     * 	
     * @return javax.swing.JMenu	
     */
    private JMenu getJMenuFile() {
        if (jMenuFile == null) {
            jMenuFile = new JMenu();
            jMenuFile.setText(LocaleFIS.GetString("File"));
            jMenuFile.add(getJMenuItemExport());
        }
        return jMenuFile;
    }

    /**
     * This method initializes jMenuItemExport	
     * 	
     * @return javax.swing.JMenuItem	
     */
    private JMenuItem getJMenuItemExport() {
        if (jMenuItemExport == null) {
            jMenuItemExport = new JMenuItem();
            jMenuItemExport.setText(LocaleFIS.GetString("Export"));
            jMenuItemExport.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    ExportDialog export = new ExportDialog();
                    export.showExportDialog(JFrame2DInfer.this, LocaleFIS.GetString("ExportViewAs"), jPanelPlot2DInfer, "export");
                }
            });
        }
        return jMenuItemExport;
    }

}
