//***********************************************************************
//
//                              JFrameSectionInfer.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.Dialog;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

import org.freehep.util.export.ExportDialog;

public class JFrameSectionInfer extends JFISChildFrame {

    private JPanel jContentPane = null;

    private JPanelSectionInfer jPanelSectionInfer = null;

    private JMenuBar jJMenuBar = null;

    private JMenu jMenuFile = null;

    private JMenuItem jMenuItemExport = null;

    /**
     * @param parent
     * @param owner
     */
    public JFrameSectionInfer(JFISFrame parent, Dialog owner) {
        super(parent, owner);
        initialize();
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setTitle(LocaleFIS.GetString("Section"));
        this.setJMenuBar(getJJMenuBar());
        this.setContentPane(getJContentPane());

    }

    public void show(JFIS fis, JPanel3DInferParameters jp3dip) throws Throwable {
        this.jPanelSectionInfer.init(fis, jp3dip);
        this.pack();
        this.setLocation(JFISChildFrame.ChildPosition(this.parent, this.getSize()));
        super.setVisible(true);
    }

    public void Translate() throws Throwable {
    // TODO Raccord de methode auto-genere

    }

    /* (non-Javadoc)
     * @see fis.JFISChildFrame#dispose()
     */
    public void dispose() {
        super.dispose();
        // efface la section
        this.jFrameSectionStateChanged(false, false, 0, 0, 0);
    }

    /**
     * This method initializes jContentPane	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            GridBagConstraints gridBagConstraints = new GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
            gridBagConstraints.weightx = 1.0D;
            gridBagConstraints.weighty = 1.0D;
            gridBagConstraints.gridy = 0;
            jContentPane = new JPanel();
            jContentPane.setLayout(new GridBagLayout());
            jContentPane.add(getJPanelSectionInfer(), gridBagConstraints);
        }
        return jContentPane;
    }

    /**
     * This method initializes jPanelSectionInfer	
     * 	
     * @return fis.JPanelSectionInfer	
     */
    private JPanelSectionInfer getJPanelSectionInfer() {
        if (jPanelSectionInfer == null) {
            jPanelSectionInfer = new JPanelSectionInfer();
            jPanelSectionInfer.addChangeListener(new javax.swing.event.ChangeListener() {
                public void stateChanged(javax.swing.event.ChangeEvent e) {
                    jFrameSectionStateChanged(jPanelSectionInfer.isSectionVisible(), jPanelSectionInfer.isXAxisSelected(), jPanelSectionInfer.getSectionValue(), jPanelSectionInfer.getSectionMin(), jPanelSectionInfer.getSectionMax());
                }
            });
        }
        return jPanelSectionInfer;
    }

    protected void jFrameSectionStateChanged(boolean showSectionSelected, boolean isXAxisSelected, double sectionValue, double sectionMin, double sectionMax) {}

    /**
     * This method initializes jJMenuBar	
     * 	
     * @return javax.swing.JMenuBar	
     */
    private JMenuBar getJJMenuBar() {
        if (jJMenuBar == null) {
            jJMenuBar = new JMenuBar();
            jJMenuBar.add(getJMenuFile());
        }
        return jJMenuBar;
    }

    /**
     * This method initializes jMenuFile	
     * 	
     * @return javax.swing.JMenu	
     */
    private JMenu getJMenuFile() {
        if (jMenuFile == null) {
            jMenuFile = new JMenu();
            jMenuFile.setText("File");
            jMenuFile.add(getJMenuItemExport());
        }
        return jMenuFile;
    }

    /**
     * This method initializes jMenuItemExport	
     * 	
     * @return javax.swing.JMenuItem	
     */
    private JMenuItem getJMenuItemExport() {
        if (jMenuItemExport == null) {
            jMenuItemExport = new JMenuItem();
            jMenuItemExport.setText("Export");
            jMenuItemExport.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    ExportDialog export = new ExportDialog();
                    export.showExportDialog(jPanelSectionInfer.getJPanelPlot2DInfer(), "Export view as ...", jPanelSectionInfer.getJPanelPlot2DInfer(), "export");
                }
            });
        }
        return jMenuItemExport;
    }
}
