//***********************************************************************
//
//                              JHFPInputFrame.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//------------------------------------------------------------------------------
public class JHFPInputFrame extends JInputFrame
{
  private JLabel jLabelNumberOfMF = new JLabel();
  private IntegerField jIFNumberOfMF = new IntegerField();
  private JPanel jPanelValidation = new JPanel(new GridBagLayout());
  private JButton jButtonCancel = new JButton();
  private JButton jButtonApply = new JButton();
  private JInputHFP input;
  private JCheckBox jCBModifyAllVariables = new JCheckBox();
  private JFISHFP hfp;
//------------------------------------------------------------------------------
  public JHFPInputFrame( JFISFrame parent, JFISHFP hfp, int input_number ) throws Throwable
    {
    super(parent);
    this.hfp = hfp;
    this.input = this.hfp.GetInput(input_number);
    this.InitComponents();

    JPanel jPanelNumberOfMF = new JPanel(new GridBagLayout());
    this.PanelInput.add(jPanelNumberOfMF,   new GridBagConstraints(0, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 5), 0, 0));
    jPanelNumberOfMF.add(jLabelNumberOfMF,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    jPanelNumberOfMF.add(jIFNumberOfMF,    new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 5), 40, 0));
    jPanelNumberOfMF.add(this.jCBModifyAllVariables,    new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 5), 0, 0));

    this.PanelInput.add(jPanelValidation,    new GridBagConstraints(0, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    jPanelValidation.add(jButtonCancel,     new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
    jPanelValidation.add(jButtonApply,    new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));

    jButtonCancel.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonCancel_actionPerformed(e); } });
    jButtonApply.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonApply_actionPerformed(e); } });

    this.jTFName.setText(this.input.GetName());
    this.jCBActive.setSelected(this.input.GetActive());
    this.dfLower.setValue(this.input.GetRange()[0]);
    this.dfUpper.setValue(this.input.GetRange()[1]);
    this.jIFNumberOfMF.setValue(this.input.GetNumberOfMF());

    // affichage
    jLabelNumberOfMF.setText(LocaleFIS.GetString("NumberOfMF") + ":");
    this.jCBModifyAllVariables.setText(LocaleFIS.GetString("ModifyAllVariables"));
    jButtonCancel.setText(LocaleFIS.GetString("Cancel"));
    jButtonApply.setText(LocaleFIS.GetString("Apply"));
    this.TranslateComponents();
    this.pack();
    this.setModal(true);
    this.setResizable(false);
    this.setLocation(JFISChildFrame.ChildPosition(this.parent, this.getSize()));
    this.setVisible(true);
    }
//------------------------------------------------------------------------------
  void jButtonCancel_actionPerformed(ActionEvent e) { this.dispose(); }
//------------------------------------------------------------------------------
  void jButtonApply_actionPerformed(ActionEvent e)
  {
  try
    {
    this.input.SetName(this.jTFName.getText());
    this.input.SetActive(this.jCBActive.isSelected());
    this.input.SetRange(this.dfLower.getValue(), this.dfUpper.getValue());
    this.input.SetNumberOfMF(this.jIFNumberOfMF.getValue());

    if( this.jCBModifyAllVariables.isSelected() )
      for( int i=0 ; i<this.hfp.GetNbInput() ; i++ )
        this.hfp.GetInput(i).SetNumberOfMF(this.jIFNumberOfMF.getValue());
    }
  catch(Throwable t) { MessageFIS.Error(null, t); }
  this.dispose();
  }
}