//***********************************************************************
//
//                              JHFPOutputFrame.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

//------------------------------------------------------------------------------
public class JHFPOutputFrame extends JOutputFrame
{
  private int OutputNumber;
  private JFISHFP hfp;
  private JPanel jPanelValidation = new JPanel(new GridBagLayout());
  private JButton jButtonCancel = new JButton();
  private JButton jButtonApply = new JButton();
//------------------------------------------------------------------------------
  public JHFPOutputFrame( JFISFrame parent, JFISHFP hfp, int output_number ) throws Throwable
  {
  super(parent);
  this.hfp = hfp;
  this.OutputNumber = output_number;
  this.fis = new JFIS(); // creation d'un sif et d'une sortie temporaire pour le bon fonctionnement de la classe JOutputFrame
  this.fis.AddOutput(new JOutput(this.hfp.GetOutput(this.OutputNumber)));
  this.Number = 0;
  this.Temp = this.fis.GetOutput(this.Number);
  this.addWindowListener(new WindowAdapter() { public void windowClosed(WindowEvent e) { JHFPOutputFrame.this.fis.Delete(); } }); // destruction du FIS temporaire
  this.setModal(true);
  this.setResizable(false);
  }
//------------------------------------------------------------------------------
  protected void jbInit() throws Throwable
  {
  super.jbInit();

  // panel validation
  this.PanelInput.add(jPanelValidation,    new GridBagConstraints(0, 4, 1, 1, 1.0, 0.0
          ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
  jPanelValidation.add(jButtonCancel,     new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
          ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
  jPanelValidation.add(jButtonApply,    new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
          ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));

  jButtonCancel.setText(LocaleFIS.GetString("Cancel"));
  jButtonApply.setText(LocaleFIS.GetString("Apply"));

  jButtonCancel.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonCancel_actionPerformed(e); } });
  jButtonApply.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonApply_actionPerformed(e); } });
  }
//------------------------------------------------------------------------------
  void jButtonCancel_actionPerformed(ActionEvent e) { this.dispose(); }
//------------------------------------------------------------------------------
  void jButtonApply_actionPerformed(ActionEvent e)
  {
  try
    {
    this.hfp.ReplaceOutput(this.OutputNumber, new JOutput((JOutput)this.Temp));
    this.dispose();
    }
  catch(Throwable t) { MessageFIS.Error(null, t); }
  }
}