//***********************************************************************
//
//                              JHFPVertexFrame.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//------------------------------------------------------------------------------
public class JHFPVertexFrame extends JFISDialog
{
  private JExtendedDataFile DataFile;
  private String HFPFile;
  private JFISFrame Parent;
  private JLabel jLabelHFPFile = new JLabel();
  private JTextField jTFHFPFile = new JTextField();
  private JButton jButtonSelectHFPFile = new JButton("...");
  //private JCheckBox jCBkmeansInitial = new JCheckBox();
  //private JLabel jLabelNbGroups = new JLabel();
  //private IntegerField jIFNbGroups = new IntegerField();
  private JLabel jLabelVertexFile = new JLabel();
  private JTextField jTFVertexFile = new JTextField();
  private JButton jButtonSelectVertexFile = new JButton("...");
  private JPanel jPanelValidation = new JPanel(new GridBagLayout());
  private JButton jButtonApply = new JButton();
  private JButton jButtonCancel = new JButton();
  private JFISHFP HFP = null;
  private JLabel jLabelNbMFs = new JLabel();
  private IntegerField jIFNbMFs = new IntegerField();
//------------------------------------------------------------------------------
  public JHFPVertexFrame( JFISFrame parent, JExtendedDataFile data_file, String hfp_file )
  {
    this.Parent = parent;
    this.DataFile = data_file;
    this.HFPFile = hfp_file;
    try { jbInit(); }
    catch(Throwable t) { MessageFIS.Error(null, t); }
  }
//------------------------------------------------------------------------------
  private void jbInit() throws Throwable
  {
    this.getContentPane().setLayout(new GridBagLayout());

    // nom du fichier hfp
    this.getContentPane().add(jLabelHFPFile,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    if( this.HFPFile != null )
      this.jTFHFPFile.setText(this.HFPFile);
    this.jTFHFPFile.setEditable(false);
    this.getContentPane().add(jTFHFPFile,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 0, 5, 5), 40, 0));
    this.getContentPane().add(jButtonSelectHFPFile,   new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 5), 0, -10));

    // kmeans initial partition
    //this.jCBkmeansInitial.setEnabled(false);
    //this.getContentPane().add(jCBkmeansInitial,  new GridBagConstraints(0, 1, 2, 1, 0.0, 0.0
    //        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    //this.getContentPane().add(jLabelNbGroups,   new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
    //        ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    //this.jIFNbGroups.setEnabled(false);
    //this.jIFNbGroups.setValue(2);
    //this.getContentPane().add(jIFNbGroups,  new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
    //        ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 5), 40, 0));

    // nom du fichier vertex
    this.getContentPane().add(jLabelVertexFile,   new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    this.jTFVertexFile.setText(this.DataFile.FileName() + ".vertices");
    this.getContentPane().add(jTFVertexFile,  new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 0, 5, 5), 40, 0));
    this.getContentPane().add(jButtonSelectVertexFile,   new GridBagConstraints(2, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 0, 5, 5), 0, -10));

    // panel validation
    jPanelValidation.add(jButtonApply,  new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelValidation.add(jButtonCancel,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanelValidation,         new GridBagConstraints(0, 6, 3, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));

    jButtonSelectHFPFile.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonSelectHFPFile_actionPerformed(e); } });
    //jCBkmeansInitial.addItemListener(new java.awt.event.ItemListener() { public void itemStateChanged(ItemEvent e) { jCBkmeansInitial_itemStateChanged(e); } });
    jButtonSelectVertexFile.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonSelectVertexFile_actionPerformed(e); } });
    jButtonApply.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonApply_actionPerformed(e); } });
    jButtonCancel.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jButtonCancel_actionPerformed(e); } });
    this.addWindowListener(new java.awt.event.WindowAdapter() { public void windowClosing(WindowEvent e) { this_windowClosing(e); } });

    // ouverture du HFP
    if( this.HFPFile != null )
      this.OpenHFP();

    // affichage
    this.Translate();
    this.pack();
    this.setModal(true);
    this.setLocation(JFISChildFrame.ChildPosition(this.Parent, this.getSize()));
    this.setVisible(true);
  }
//------------------------------------------------------------------------------
  private void Translate()
  {
    this.setTitle(LocaleFIS.GetString("GenerateVertices"));
    this.jLabelHFPFile.setText(LocaleFIS.GetString("HFPFile") + ":");
    //jCBkmeansInitial.setText(LocaleFIS.GetString("kmeansInitialPartition"));
    //jLabelNbGroups.setText(LocaleFIS.GetString("NbGroups") + ":");
    jLabelNbMFs.setText(LocaleFIS.GetString("NumberOfMF") + ":");
    this.jLabelVertexFile.setText(LocaleFIS.GetString("VerticesFile") + ":");
    jButtonApply.setText(LocaleFIS.GetString("Apply"));
    jButtonCancel.setText(LocaleFIS.GetString("Cancel"));
  }
//------------------------------------------------------------------------------
  void jButtonSelectHFPFile_actionPerformed(ActionEvent e)
  {
  JOpenFileChooser file_chooser = new JOpenFileChooser(MainFIS.config.FISFilePath());
  file_chooser.setSelectedFile(new File(this.jTFHFPFile.getText()));
  file_chooser.setAcceptAllFileFilterUsed(true);
  // ajout du filtre *.hfp
  JFileFilter filter = new JFileFilter(new String("hfp"), LocaleFIS.GetString("HFPFile"));
  file_chooser.addChoosableFileFilter(filter);
  if( file_chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION )
    {
    this.HFPFile = file_chooser.getSelectedFile().getAbsolutePath();
    this.jTFHFPFile.setText(this.HFPFile);
    this.OpenHFP();
    }
  }
//------------------------------------------------------------------------------
  private void OpenHFP()
  {
  try
    {
    if( this.HFP != null )
      this.HFP.Delete();
    if( this.HFPFile.equals("") == true )
      return;
    this.HFP = new JFISHFP(this.DataFile.ActiveFileName(), this.HFPFile);
    //this.jCBkmeansInitial.setSelected(false);
    /*if( this.HFP.GetHierarchy() == JFISHFP.HFP )
      this.jCBkmeansInitial.setEnabled(true);
    else
      this.jCBkmeansInitial.setEnabled(false);*/
    }
  catch( Throwable t ) { MessageFIS.Error(null, t); }
  }
//------------------------------------------------------------------------------
  void jButtonSelectVertexFile_actionPerformed(ActionEvent e)
  {
  JOpenFileChooser file_chooser = new JOpenFileChooser(MainFIS.config.FISFilePath());
  file_chooser.setSelectedFile(new File(this.jTFVertexFile.getText()));
  file_chooser.setAcceptAllFileFilterUsed(true);
  // ajout du filtre *.vertices
  JFileFilter filter = new JFileFilter(new String("vertices"), LocaleFIS.GetString("VerticesFile"));
  file_chooser.addChoosableFileFilter(filter);
  if( file_chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION )
    {
    String file_name = file_chooser.getSelectedFile().getAbsolutePath();
    // teste si le fichier existe
    File f = new File( file_name );
    if( f.exists() )
      {
      String message = LocaleFIS.GetString("TheVerticesFile") + " : " + file_name + " " + LocaleFIS.GetString("AlreadyExist") + "\n" + LocaleFIS.GetString("DoYouWantToReplaceIt");
      if( MessageFIS.Confirm(this, message) == JOptionPane.NO_OPTION )
        return;
      }
    this.jTFVertexFile.setText(file_name);
    }
  }
//------------------------------------------------------------------------------
  /*void jCBkmeansInitial_itemStateChanged(ItemEvent e)
  {
  if( this.jCBkmeansInitial.isSelected() == true )
    this.jIFNbGroups.setEnabled(true);
  else
    this.jIFNbGroups.setEnabled(false);
  }*/
//------------------------------------------------------------------------------
  void jButtonCancel_actionPerformed(ActionEvent e) { this.jTFVertexFile.setText(null); this.dispose(); }
//------------------------------------------------------------------------------
  void jButtonApply_actionPerformed(ActionEvent e)
  {
  try
    {
    if( this.jTFHFPFile.getText().equals("") )
      {
      JOptionPane.showConfirmDialog(this, LocaleFIS.GetString("SelectAHFPFile"), null, JOptionPane.CLOSED_OPTION , JOptionPane.INFORMATION_MESSAGE );
      return;
      }
    if( this.jTFVertexFile.getText().equals("") )
      {
      JOptionPane.showConfirmDialog(this, LocaleFIS.GetString("SelectAVerticesFile"), null, JOptionPane.CLOSED_OPTION , JOptionPane.INFORMATION_MESSAGE );
      return;
      }
    /*int nb_groups = 0;
    if( this.jCBkmeansInitial.isSelected() == true )
      nb_groups = this.jIFNbGroups.getValue();*/

      // recuperer tolerance du fichier hfp et si > 1 la passer a JFISHFP.Vertex

    JFISHFP.Vertex(this.DataFile.ActiveFileName(), this.jTFHFPFile.getText(), this.jTFVertexFile.getText());
    JFISConsole jc = new JFISConsole(this.Parent, this.jTFVertexFile.getText());
    this.dispose();
    }
  catch( Throwable except ) { MessageFIS.Error( null, except ); }
  }
//------------------------------------------------------------------------------
  String GetVertexFile() { return this.jTFVertexFile.getText(); }
//------------------------------------------------------------------------------
  String GetHFPFile() { return this.jTFHFPFile.getText(); }
//------------------------------------------------------------------------------
  void this_windowClosing(WindowEvent e) { this.dispose(); }
//------------------------------------------------------------------------------
  public void dispose()
  {
  super.dispose();
  if( this.HFP != null )
    {
    try { this.HFP.Delete(); }
    catch( Throwable t ) { MessageFIS.Error(null, t); }
    }
  }
}
