//***********************************************************************
//
//                             JPanel3DInferParameters.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.GridBagConstraints;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

import util.JDoubleMThumbSliderSpinner;

public class JPanel3DInferParameters extends JPanel2DInferParameters {

    private JLabel jLabelY = null;

    private JComboBoxInputs jComboBoxInputY = null;

    private JComboBoxInputsGroup jComboBoxInputsGroup = new JComboBoxInputsGroup();

    private JSpinner jSpinnerYResolution = null;

    private SpinnerNumberModel spinnerNumberModelYResolution = null; //  @jve:decl-index=0:visual-constraint="519,18"

    private JDoubleMThumbSliderSpinner jDoubleMThumbSliderSpinnerY = null;

    private JSpinner jSpinnerYMin = null;

    private JSpinner jSpinnerYMax = null;

    private JMFsPanel jPanelMFY = null;

    private int previousSelectedIndexY = -1;

    /**
     * This method initializes 
     * 
     */
    public JPanel3DInferParameters() {
        super();
        initialize();
    }

    public void init(JFIS fis, boolean showCollapseButtons) throws Throwable {
        super.init(fis, showCollapseButtons);
        this.jComboBoxInputsGroup.add(this.jComboBoxInputX);
        this.jComboBoxInputsGroup.add(this.jComboBoxInputY);
        this.jComboBoxInputY.setInputs(this.fis.GetInputs());
        if (showCollapseButtons == true)
            this.jButtonCollapseOtherInputs.setVisible(this.jPanelInputsValue.isVisible());
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setSize(new java.awt.Dimension(447, 234));
        GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
        gridBagConstraints2.gridx = 5;
        gridBagConstraints2.gridheight = 2;
        gridBagConstraints2.insets = new java.awt.Insets(5, 5, 0, 5);
        gridBagConstraints2.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints2.weightx = 1.0D;
        gridBagConstraints2.gridy = 3;
        GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
        gridBagConstraints7.gridx = 4;
        gridBagConstraints7.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints7.ipadx = 20;
        gridBagConstraints7.gridy = 3;
        GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
        gridBagConstraints6.gridx = 3;
        gridBagConstraints6.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints6.ipadx = 20;
        gridBagConstraints6.gridy = 3;
        GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
        gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints5.gridy = 4;
        gridBagConstraints5.weightx = 1.0;
        gridBagConstraints5.gridwidth = 2;
        gridBagConstraints5.insets = new java.awt.Insets(0, 5, 0, 5);
        gridBagConstraints5.gridx = 3;
        GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
        gridBagConstraints4.gridx = 2;
        gridBagConstraints4.gridheight = 2;
        gridBagConstraints4.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints4.gridy = 3;
        GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
        gridBagConstraints3.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints3.gridy = 3;
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints3.gridheight = 2;
        gridBagConstraints3.gridx = 1;
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.gridy = 3;
        jLabelY = new JLabel();
        jLabelY.setText("Y");
        jLabelOutput.setText("Z");
        this.jPanelAxesSelection.add(jLabelY, gridBagConstraints);
        this.jPanelAxesSelection.add(getJComboBoxInputY(), gridBagConstraints3);
        this.jPanelAxesSelection.add(getJSpinnerYRes(), gridBagConstraints4);
        this.jPanelAxesSelection.add(getJDoubleMThumbSliderSpinnerY(), gridBagConstraints5);
        this.jPanelAxesSelection.add(getJSpinnerYMin(), gridBagConstraints6);
        this.jPanelAxesSelection.add(getJSpinnerYMax(), gridBagConstraints7);
        this.jPanelAxesSelection.add(getJPanelMFY(), gridBagConstraints2);
    }

    /**
     * This method initializes jComboBoxInputY	
     * 	
     * @return fis.JComboBoxInputs	
     */
    private JComboBoxInputs getJComboBoxInputY() {
        if (jComboBoxInputY == null) {
            jComboBoxInputY = new JComboBoxInputs();
            jComboBoxInputY.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    int selectedIndex = ((JComboBox) e.getSource()).getSelectedIndex();
                    try {
                        double[] range = fis.GetInput(selectedIndex).GetRange();
                        jDoubleMThumbSliderSpinnerY.setDoubleMinMax(range[0], range[1]);
                        jPanelMFY.SetInput(fis.GetInput(selectedIndex));
                        jPanelMFY.addCursor(range[0]);
                        jPanelMFY.addCursor(range[1]);
                        if (previousSelectedIndexY != -1)
                            jPanelInputsValue.setInputVisible(previousSelectedIndexY, true);
                        jPanelInputsValue.setInputVisible(selectedIndex, false);
                        previousSelectedIndexY = selectedIndex;
                        fireStateChanged();
                    } catch (Throwable e1) {
                        // TODO Bloc catch auto-genere
                        e1.printStackTrace();
                    }
                }
            });
        }
        return jComboBoxInputY;
    }

    /**
     * This method initializes jSpinnerYRes	
     * 	
     * @return javax.swing.JSpinner	
     */
    private JSpinner getJSpinnerYRes() {
        if (jSpinnerYResolution == null) {
            jSpinnerYResolution = new JSpinner();
            jSpinnerYResolution.setVisible(false);
            jSpinnerYResolution.setModel(getSpinnerNumberModelYResolution());
        }
        return jSpinnerYResolution;
    }

    /**
     * This method initializes spinnerNumberModelY	
     * 	
     * @return javax.swing.SpinnerNumberModel	
     */
    private SpinnerNumberModel getSpinnerNumberModelYResolution() {
        if (spinnerNumberModelYResolution == null) {
            spinnerNumberModelYResolution = new SpinnerNumberModel(40, 10, 100, 1);
        }
        return spinnerNumberModelYResolution;
    }

    /**
     * This method initializes jDouble2ThumbSliderSpinnerY	
     * 	
     * @return util.JDouble2ThumbSliderSpinner	
     */
    private JDoubleMThumbSliderSpinner getJDoubleMThumbSliderSpinnerY() {
        if (jDoubleMThumbSliderSpinnerY == null) {
            jDoubleMThumbSliderSpinnerY = new JDoubleMThumbSliderSpinner(2);
            jDoubleMThumbSliderSpinnerY.addChangeListener(new javax.swing.event.ChangeListener() {
                public void stateChanged(javax.swing.event.ChangeEvent e) {
                    jPanelMFY.setCursor(0, jDoubleMThumbSliderSpinnerY.getDoubleValue(0));
                    jPanelMFY.setCursor(1, jDoubleMThumbSliderSpinnerY.getDoubleValue(1));
                    fireStateChanged();
                }
            });
        }
        return jDoubleMThumbSliderSpinnerY;
    }

    /**
     * This method initializes jSpinnerYMin	
     * 	
     * @return javax.swing.JSpinner	
     */
    private JSpinner getJSpinnerYMin() {
        if (jSpinnerYMin == null) {
            jSpinnerYMin = this.jDoubleMThumbSliderSpinnerY.getSpinners()[0];
        }
        return jSpinnerYMin;
    }

    /**
     * This method initializes jSpinnerYMax	
     * 	
     * @return javax.swing.JSpinner	
     */
    private JSpinner getJSpinnerYMax() {
        if (jSpinnerYMax == null) {
            jSpinnerYMax = this.jDoubleMThumbSliderSpinnerY.getSpinners()[1];
        }
        return jSpinnerYMax;
    }

    /**
     * This method initializes jPanelMFY	
     * 	
     * @return fis.JMFsPanel	
     */
    private JMFsPanel getJPanelMFY() {
        if (jPanelMFY == null) {
            jPanelMFY = new JMFsPanel() {

				@Override
				public java.awt.Dimension getMinimumSize() {
					return new java.awt.Dimension(100, 50);
				}};
            jPanelMFY.setSize(new java.awt.Dimension(100, 50));
            jPanelMFY.setShowTicks(false);
        }
        return jPanelMFY;
    }

    public int selectedYInput() {
        return this.jComboBoxInputY.getSelectedIndex();
    }

    public int yResolution() {
        return ((Integer) this.jSpinnerYResolution.getValue()).intValue();
    }

    public double yMin() {
        return this.jDoubleMThumbSliderSpinnerY.getDoubleValue(0);
    }

    public double yMax() {
        return this.jDoubleMThumbSliderSpinnerY.getDoubleValue(1);
    }

    /* (non-Javadoc)
     * @see fis.JFISPanel#fireStateChanged()
     */
    protected void fireStateChanged() {
        if ((this.jComboBoxInputX.getSelectedIndex() != -1) && (this.jComboBoxInputY.getSelectedIndex() != -1) && (this.jComboBoxOutput.getSelectedIndex() != -1))
            super.fireStateChanged();
    }

}
