//***********************************************************************
//
//                              JPanelFPA.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.JPanel;

import java.awt.Component;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import javax.swing.JComboBox;

public class JPanelFPA extends JPanel {

    private JLabel jLabelStrategy = null;

    private JComboBox jComboBoxStrategy = null;

    private JLabel jLabelMinCard = null;

    private JLabel jLabelMinDeg = null;

    private IntegerField integerFieldMinCard = null;

    private DoubleField doubleFieldMinDeg = null;

    /**
     * This is the default constructor
     */
    public JPanelFPA() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
        gridBagConstraints5.gridy = 2;
        gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints5.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints5.ipadx = 40;
        gridBagConstraints5.gridx = 1;
        GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
        gridBagConstraints4.gridy = 1;
        gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints4.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints4.ipadx = 40;
        gridBagConstraints4.gridx = 1;
        GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints3.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints3.gridy = 2;
        jLabelMinDeg = new JLabel();
        jLabelMinDeg.setText(LocaleFIS.GetString("MinDeg") + " :");
        GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints2.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints2.gridy = 1;
        jLabelMinCard = new JLabel();
        jLabelMinCard.setText(LocaleFIS.GetString("MinCard") + " :");
        GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints1.gridx = 1;
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.gridy = 0;
        jLabelStrategy = new JLabel();
        jLabelStrategy.setText(LocaleFIS.GetString("Strategy") + " :");
        this.setLayout(new GridBagLayout());
        this.setSize(300, 200);
        this.add(jLabelStrategy, gridBagConstraints);
        this.add(getJComboBoxStrategy(), gridBagConstraints1);
        this.add(jLabelMinCard, gridBagConstraints2);
        this.add(jLabelMinDeg, gridBagConstraints3);
        this.add(getIntegerFieldMinCard(), gridBagConstraints4);
        this.add(getDoubleFieldMinDeg(), gridBagConstraints5);
    }

    /**
     * This method initializes jComboBoxStrategy	
     * 	
     * @return javax.swing.JComboBox	
     */
    private JComboBox getJComboBoxStrategy() {
        if (jComboBoxStrategy == null) {
            jComboBoxStrategy = new JComboBox();
            jComboBoxStrategy.addItem(LocaleFIS.GetString("min"));
            jComboBoxStrategy.addItem(LocaleFIS.GetString("decrease"));
            jComboBoxStrategy.setSelectedIndex(1);
        }
        return jComboBoxStrategy;
    }

    /**
     * This method initializes integerFieldMinCard	
     * 	
     * @return fis.IntegerField	
     */
    private IntegerField getIntegerFieldMinCard() {
        if (integerFieldMinCard == null) {
            integerFieldMinCard = new IntegerField();
            integerFieldMinCard.setValue(3);
        }
        return integerFieldMinCard;
    }

    /**
     * This method initializes doubleFieldMinDeg	
     * 	
     * @return fis.DoubleField	
     */
    private DoubleField getDoubleFieldMinDeg() {
        if (doubleFieldMinDeg == null) {
            doubleFieldMinDeg = new DoubleField();
            doubleFieldMinDeg.setValue(0.3D);
        }
        return doubleFieldMinDeg;
    }

    /* (non-Javadoc)
     * @see javax.swing.JComponent#setEnabled(boolean)
     */
    public void setEnabled(boolean enabled) {
        Component[] components = this.getComponents();
        for (int i = 0; i < components.length; i++)
            components[i].setEnabled(enabled);
    }

    public int getStrategy() {
        return this.jComboBoxStrategy.getSelectedIndex();
    }

    public int getMinCardinality() {
        return this.integerFieldMinCard.getValue();
    }

    public double getMinDegree() {
        return this.doubleFieldMinDeg.getValue();
    }

}
