//***********************************************************************
//
//                              JPanelGenerateConclusions.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JRadioButton;
import java.awt.GridBagConstraints;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;

import util.skt.swing.border.ComponentTitledBorder;

public class JPanelGenerateConclusions extends JPanel {

    private JRadioButton jRadioButtonFPA = null;

    private JRadioButton jRadioButtonOLS = null;

    private ButtonGroup buttonGroupMethod = null;

    private JCheckBox jCheckBoxOutputVocabularyReduction = null; //  @jve:decl-index=0:visual-constraint="50,250"

    private JPanelOutputVocabularyReduction jPanelOutputVocabularyReduction = null;

    public static int FPA = 0;

    public static int OLS = 1;

    /**
     * This is the default constructor
     */
    public JPanelGenerateConclusions() {
        super();
        initialize();
        this.getButtonGroupMethod().add(this.jRadioButtonFPA);
        this.getButtonGroupMethod().add(this.jRadioButtonOLS);
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
        gridBagConstraints7.gridx = 0;
        gridBagConstraints7.gridwidth = 2;
        gridBagConstraints7.insets = new java.awt.Insets(5, 0, 0, 0);
        gridBagConstraints7.gridy = 2;
        GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.gridy = 1;
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.gridy = 0;
        this.setLayout(new GridBagLayout());
        this.setSize(400, 250);
        this.add(getJRadioButtonFPA(), gridBagConstraints);
        this.add(getJRadioButtonOLS(), gridBagConstraints1);
        this.add(getJPanelOutputVocabularyReduction(), gridBagConstraints7);
    }

    /**
     * This method initializes jRadioButtonFPA	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonFPA() {
        if (jRadioButtonFPA == null) {
            jRadioButtonFPA = new JRadioButton();
            jRadioButtonFPA.setText("FPA");
            jRadioButtonFPA.setSelected(true);
        }
        return jRadioButtonFPA;
    }

    /**
     * This method initializes jRadioButtonOLS	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonOLS() {
        if (jRadioButtonOLS == null) {
            jRadioButtonOLS = new JRadioButton();
            jRadioButtonOLS.setText("OLS");
        }
        return jRadioButtonOLS;
    }

    /**
     * This method initializes buttonGroupMethod	
     * 	
     * @return javax.swing.ButtonGroup	
     */
    private ButtonGroup getButtonGroupMethod() {
        if (buttonGroupMethod == null) {
            buttonGroupMethod = new ButtonGroup();
        }
        return buttonGroupMethod;
    }

    /**
     * This method initializes jCheckBoxOutputVocabularyReduction	
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxOutputVocabularyReduction() {
        if (jCheckBoxOutputVocabularyReduction == null) {
            jCheckBoxOutputVocabularyReduction = new JCheckBox();
            jCheckBoxOutputVocabularyReduction.setText(LocaleFIS.GetString("OutputVocabularyReduction"));
            jCheckBoxOutputVocabularyReduction.setSelected(true);
            jCheckBoxOutputVocabularyReduction.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    jPanelOutputVocabularyReduction.setEnabled(jCheckBoxOutputVocabularyReduction.isSelected());
                }
            });
        }
        return jCheckBoxOutputVocabularyReduction;
    }

    /**
     * This method initializes jPanelOutputVocabularyReduction	
     * 	
     * @return fis.JPanelOutputVocabularyReduction	
     */
    public JPanelOutputVocabularyReduction getJPanelOutputVocabularyReduction() {
        if (jPanelOutputVocabularyReduction == null) {
            jPanelOutputVocabularyReduction = new JPanelOutputVocabularyReduction();
            jPanelOutputVocabularyReduction.setBorder(new ComponentTitledBorder(this.getJCheckBoxOutputVocabularyReduction(), jPanelOutputVocabularyReduction, BorderFactory.createTitledBorder("")));
        }
        return jPanelOutputVocabularyReduction;
    }

    public int getMethod() {
        return this.jRadioButtonFPA.isSelected() ? FPA : OLS;
    }

    public boolean getReduceVocabulary() {
        return this.jCheckBoxOutputVocabularyReduction.isSelected();
    }

}
