package fis;

import java.awt.GridBagLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import java.awt.Color;

public class JPanelInferErrorRegression extends JPanel {

	private static final long serialVersionUID = 1L;
	private JLabel jLabelPI = null;
	private JLabel jLabelRMSE = null;
	private JLabel MAE = null;
	private DoubleField doubleFieldPI = null;
	private DoubleField doubleFieldRMSE = null;
	private DoubleField doubleFieldMAE = null;

	/**
	 * This is the default constructor
	 */
	public JPanelInferErrorRegression() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints5.gridy = 2;
		gridBagConstraints5.anchor = GridBagConstraints.WEST;
		gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
		gridBagConstraints5.ipadx = 40;
		gridBagConstraints5.gridx = 1;
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints4.gridy = 1;
		gridBagConstraints4.anchor = GridBagConstraints.WEST;
		gridBagConstraints4.ipadx = 40;
		gridBagConstraints4.insets = new Insets(5, 5, 0, 5);
		gridBagConstraints4.gridx = 1;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints3.gridy = 0;
		gridBagConstraints3.anchor = GridBagConstraints.WEST;
		gridBagConstraints3.insets = new Insets(0, 5, 0, 5);
		gridBagConstraints3.ipadx = 40;
		gridBagConstraints3.gridx = 1;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.anchor = GridBagConstraints.EAST;
		gridBagConstraints2.insets = new Insets(5, 5, 5, 0);
		gridBagConstraints2.gridy = 2;
		MAE = new JLabel();
		MAE.setText("MAE");
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.anchor = GridBagConstraints.EAST;
		gridBagConstraints1.insets = new Insets(5, 5, 0, 0);
		gridBagConstraints1.gridy = 1;
		jLabelRMSE = new JLabel();
		jLabelRMSE.setText("RMSE");
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.anchor = GridBagConstraints.EAST;
		gridBagConstraints.insets = new Insets(0, 5, 0, 0);
		gridBagConstraints.gridy = 0;
		jLabelPI = new JLabel();
		jLabelPI.setText("PI");
		this.setSize(300, 200);
		this.setLayout(new GridBagLayout());
		this.setBorder(BorderFactory.createTitledBorder(null, "Error", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)));
		this.add(jLabelPI, gridBagConstraints);
		this.add(jLabelRMSE, gridBagConstraints1);
		this.add(MAE, gridBagConstraints2);
		this.add(getDoubleFieldPI(), gridBagConstraints3);
		this.add(getDoubleFieldRMSE(), gridBagConstraints4);
		this.add(getDoubleFieldMAE(), gridBagConstraints5);
	}

	/**
	 * This method initializes doubleFieldPI	
	 * 	
	 * @return fis.DoubleField	
	 */
	private DoubleField getDoubleFieldPI() {
		if (doubleFieldPI == null) {
			doubleFieldPI = new DoubleField();
			doubleFieldPI.setEditable(false);
		}
		return doubleFieldPI;
	}

	/**
	 * This method initializes doubleFieldRMSE	
	 * 	
	 * @return fis.DoubleField	
	 */
	private DoubleField getDoubleFieldRMSE() {
		if (doubleFieldRMSE == null) {
			doubleFieldRMSE = new DoubleField();
			doubleFieldRMSE.setEditable(false);
		}
		return doubleFieldRMSE;
	}

	/**
	 * This method initializes doubleFieldMAE	
	 * 	
	 * @return fis.DoubleField	
	 */
	private DoubleField getDoubleFieldMAE() {
		if (doubleFieldMAE == null) {
			doubleFieldMAE = new DoubleField();
			doubleFieldMAE.setEditable(false);
		}
		return doubleFieldMAE;
	}

	public void setValues(double [] values) {
		this.doubleFieldPI.setValue(values[0]);
		this.doubleFieldRMSE.setValue(values[1]);
		this.doubleFieldMAE.setValue(values[2]);
	}
}
