//***********************************************************************
//
//                              JPanelOutputVocabularyReduction.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JCheckBox;
import java.awt.GridBagConstraints;
import javax.swing.JRadioButton;
import javax.swing.JLabel;
import javax.swing.ButtonGroup;

public class JPanelOutputVocabularyReduction extends JPanel {

    private JRadioButton jRadioButtonNumberOfConc = null;

    private JRadioButton jRadioButtonDegradationAllowed = null;

    private IntegerField integerFieldNumberOfConc = null;

    private DoubleField doubleFieldDegradationAllowed = null;

    private JLabel jLabelPercent = null;

    private ButtonGroup buttonGroup = null;

    private JRadioButton jRadioButtonUseRuleConc = null;

    private JRadioButton jRadioButtonUseOutputData = null;

    private ButtonGroup buttonGroupDataUsed = null;

    private JPanel jPanelBlankTresh = null;

    private JLabel jLabelBlankThresh = null;

    private DoubleField doubleFieldBlankThresh = null;

    /**
     * This is the default constructor
     */
    public JPanelOutputVocabularyReduction() {
        super();
        initialize();
        this.getButtonGroupDataUsed().add(this.jRadioButtonUseRuleConc);
        this.getButtonGroupDataUsed().add(this.jRadioButtonUseOutputData);
        this.getButtonGroup().add(this.jRadioButtonNumberOfConc);
        this.getButtonGroup().add(this.jRadioButtonDegradationAllowed);
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
        gridBagConstraints7.gridx = 0;
        gridBagConstraints7.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints7.gridwidth = 3;
        gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints7.gridy = 4;
        GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
        gridBagConstraints6.gridx = 0;
        gridBagConstraints6.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints6.gridwidth = 3;
        gridBagConstraints6.gridy = 1;
        GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.gridy = 0;
        GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
        gridBagConstraints5.gridx = 2;
        gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints5.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints5.gridy = 3;
        jLabelPercent = new JLabel();
        jLabelPercent.setText("%");
        GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints4.gridy = 3;
        gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints4.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints4.ipadx = 40;
        gridBagConstraints4.gridx = 1;
        GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
        gridBagConstraints3.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints3.gridy = 2;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints3.ipadx = 40;
        gridBagConstraints3.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints3.gridx = 1;
        GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.gridy = 3;
        GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.gridy = 2;
        this.setLayout(new GridBagLayout());
        this.setSize(300, 200);
        this.add(getJRadioButtonNumberOfConc(), gridBagConstraints1);
        this.add(getJRadioButtonDegradationAllowed(), gridBagConstraints2);
        this.add(getIntegerFieldNumberOfConc(), gridBagConstraints3);
        this.add(getDoubleFieldDegradationAllowed(), gridBagConstraints4);
        this.add(jLabelPercent, gridBagConstraints5);
        this.add(getJRadioButtonUseRuleConc(), gridBagConstraints);
        this.add(getJRadioButtonUseOutputData(), gridBagConstraints6);
        this.add(getJPanelBlankTresh(), gridBagConstraints7);
    }

    /**
     * This method initializes jRadioButtonNumberOfConc	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonNumberOfConc() {
        if (jRadioButtonNumberOfConc == null) {
            jRadioButtonNumberOfConc = new JRadioButton();
            jRadioButtonNumberOfConc.setText(LocaleFIS.GetString("NumberOfConc"));
            jRadioButtonNumberOfConc.setSelected(true);
            jRadioButtonNumberOfConc.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    integerFieldNumberOfConc.setEnabled(true);
                    doubleFieldDegradationAllowed.setEnabled(false);
                    jLabelBlankThresh.setEnabled(false);
                    doubleFieldBlankThresh.setEnabled(false);
                }
            });
        }
        return jRadioButtonNumberOfConc;
    }

    /**
     * This method initializes jRadioButtonDegradationAllowed	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonDegradationAllowed() {
        if (jRadioButtonDegradationAllowed == null) {
            jRadioButtonDegradationAllowed = new JRadioButton();
            jRadioButtonDegradationAllowed.setText(LocaleFIS.GetString("DegradationAllowed"));
            jRadioButtonDegradationAllowed.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    integerFieldNumberOfConc.setEnabled(false);
                    doubleFieldDegradationAllowed.setEnabled(true);
                    jLabelBlankThresh.setEnabled(true);
                    doubleFieldBlankThresh.setEnabled(true);
                }
            });
        }
        return jRadioButtonDegradationAllowed;
    }

    /**
     * This method initializes integerFieldNumberOfConc	
     * 	
     * @return fis.IntegerField	
     */
    private IntegerField getIntegerFieldNumberOfConc() {
        if (integerFieldNumberOfConc == null) {
            integerFieldNumberOfConc = new IntegerField();
            integerFieldNumberOfConc.setValue(7);
        }
        return integerFieldNumberOfConc;
    }

    /**
     * This method initializes doubleFieldDegradationAllowed	
     * 	
     * @return fis.DoubleField	
     */
    private DoubleField getDoubleFieldDegradationAllowed() {
        if (doubleFieldDegradationAllowed == null) {
            doubleFieldDegradationAllowed = new DoubleField();
            doubleFieldDegradationAllowed.setValue(10.0D);
            doubleFieldDegradationAllowed.setEnabled(false);
        }
        return doubleFieldDegradationAllowed;
    }

    /**
     * This method initializes buttonGroup	
     * 	
     * @return javax.swing.ButtonGroup	
     */
    private ButtonGroup getButtonGroup() {
        if (buttonGroup == null) {
            buttonGroup = new ButtonGroup();
        }
        return buttonGroup;
    }

    /* (non-Javadoc)
     * @see javax.swing.JComponent#setEnabled(boolean)
     */
    public void setEnabled(boolean enabled) {
        super.setEnabled(enabled);
        this.jRadioButtonUseRuleConc.setEnabled(enabled);
        this.jRadioButtonUseOutputData.setEnabled(enabled);
        this.jRadioButtonDegradationAllowed.setEnabled(enabled);
        this.jRadioButtonNumberOfConc.setEnabled(enabled);
        this.jLabelPercent.setEnabled(enabled);
        this.doubleFieldDegradationAllowed.setEnabled(enabled == false ? false : this.jRadioButtonDegradationAllowed.isSelected());
        this.jLabelBlankThresh.setEnabled(enabled == false ? false : this.jRadioButtonDegradationAllowed.isSelected());
        this.doubleFieldBlankThresh.setEnabled(enabled == false ? false : this.jRadioButtonDegradationAllowed.isSelected());
        this.integerFieldNumberOfConc.setEnabled(enabled == false ? false : this.jRadioButtonNumberOfConc.isSelected());
    }

    /**
     * This method initializes jRadioButtonUseRuleConc	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonUseRuleConc() {
        if (jRadioButtonUseRuleConc == null) {
            jRadioButtonUseRuleConc = new JRadioButton();
            jRadioButtonUseRuleConc.setText(LocaleFIS.GetString("UseRuleConc"));
            jRadioButtonUseRuleConc.setSelected(true);
        }
        return jRadioButtonUseRuleConc;
    }

    /**
     * This method initializes jRadioButtonUseOutputData	
     * 	
     * @return javax.swing.JRadioButton	
     */
    private JRadioButton getJRadioButtonUseOutputData() {
        if (jRadioButtonUseOutputData == null) {
            jRadioButtonUseOutputData = new JRadioButton();
            jRadioButtonUseOutputData.setText(LocaleFIS.GetString("UseOutputData"));
        }
        return jRadioButtonUseOutputData;
    }

    /**
     * This method initializes buttonGroupDataUsed	
     * 	
     * @return javax.swing.ButtonGroup	
     */
    private ButtonGroup getButtonGroupDataUsed() {
        if (buttonGroupDataUsed == null) {
            buttonGroupDataUsed = new ButtonGroup();
        }
        return buttonGroupDataUsed;
    }

    /**
     * This method initializes jPanelBlankTresh	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanelBlankTresh() {
        if (jPanelBlankTresh == null) {
            GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
            gridBagConstraints9.fill = java.awt.GridBagConstraints.NONE;
            gridBagConstraints9.gridy = 0;
            gridBagConstraints9.weightx = 1.0;
            gridBagConstraints9.anchor = java.awt.GridBagConstraints.WEST;
            gridBagConstraints9.insets = new java.awt.Insets(5, 5, 0, 5);
            gridBagConstraints9.ipadx = 40;
            gridBagConstraints9.gridx = 1;
            GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
            gridBagConstraints8.anchor = java.awt.GridBagConstraints.WEST;
            gridBagConstraints8.gridy = 0;
            gridBagConstraints8.insets = new java.awt.Insets(5, 5, 0, 0);
            gridBagConstraints8.gridx = 0;
            jLabelBlankThresh = new JLabel();
            jLabelBlankThresh.setText(LocaleFIS.GetString("BlankThres") + ":");
            jLabelBlankThresh.setEnabled(false);
            jPanelBlankTresh = new JPanel();
            jPanelBlankTresh.setLayout(new GridBagLayout());
            jPanelBlankTresh.add(jLabelBlankThresh, gridBagConstraints8);
            jPanelBlankTresh.add(getDoubleFieldBlankThresh(), gridBagConstraints9);
        }
        return jPanelBlankTresh;
    }

    /**
     * This method initializes doubleFieldBlankThresh	
     * 	
     * @return fis.DoubleField	
     */
    private DoubleField getDoubleFieldBlankThresh() {
        if (doubleFieldBlankThresh == null) {
            doubleFieldBlankThresh = new DoubleField();
            doubleFieldBlankThresh.setValue(0.1D);
            doubleFieldBlankThresh.setEnabled(false);
        }
        return doubleFieldBlankThresh;
    }

    public void hideBlankTreshold() {
        this.jLabelBlankThresh.setVisible(false);
        this.doubleFieldBlankThresh.setVisible(false);
    }

    public double getDegradationAllowed() {
        return this.doubleFieldDegradationAllowed.getValue() / 100;
    }

    public double getBlankThresh() {
        return this.doubleFieldBlankThresh.getValue();
    }

    public int getNumberOfConc() {
        return this.integerFieldNumberOfConc.getValue();
    }

    public boolean getUseRuleConc() {
        return this.jRadioButtonUseRuleConc.isSelected();
    }
}
