//***********************************************************************
//
//                              JPerformanceFrame.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.border.*;
import java.util.*;
import java.awt.geom.*;
import javax.swing.event.*;

//------------------------------------------------------------------------------
public class JPerformanceFrame extends JFISChildFrame
{
	private JMoveFile [] result_file;
	private JFIS fis;
	private JExtendedDataFile DataFile;
	private TitledBorder jBorderOutput;
	private JFileListener JFileListener;
	private JLabel jLabelBlankThres = new JLabel();
	private DoubleField jdfBlankThres = new DoubleField();
	private JCheckBox jcbComputeLinks = new JCheckBox();
	private JButton jbCompute = new JButton();
	private ButtonGroup jbgOutput;
	private JLabel jLabelInferErrorClassif = new JLabel();
	private JLabel jLabelCoveradge = new JLabel();
	private JLabel jLabelMaxError = new JLabel();
	private DoubleField jdfInferErrorClassif = new DoubleField();
	private JPanelInferErrorRegression jPanelInferErrorRegression = new JPanelInferErrorRegression();
	private DoubleField jdfCoveradge = new DoubleField();
	private DoubleField jdfMaxError = new DoubleField();
	private TitledBorder titledBorderResult;
	private JPanel jPanelResult = new JPanel(new GridBagLayout());
	private FISListener FISListener;
	private JPanel jPanelOutput;
	private double PerfResult;
	private PerformanceFile [] PerfFile;
	private int OutputSelected = -1;
	private int InferedOutput;
	private int NbInputs;
	private JSemaphore JPerformanceFrameOpen;   // semaphore d'ouverture de la fenetre JPerformanceFrame
	private InferedDataXYFrame [] jFrameXYErrorObserved;
	private InferedDataXYFrame [] jFrameXYInferedObserved;
	private DataHistogramInputFrame [] jFrameHistoObserved;
	private DataHistogramInputFrame [] jFrameHistoInfered;
	private DataHistogramFrame [] jFrameHistoError;
	private JClassifInfFrame [] jFrameClassifInf;
	private JAdequationFrame [] jFrameAdequation;
	// gestion des menus
	private JMenuBar jMenuBar = new JMenuBar();
	private JMenu jMenuResults = new JMenu();
	private JMenuItem jMenuSaveAs = new JMenuItem();
	// menu View results
	private JMenu jMenuViewResults = new JMenu();
	private JMenu jMenuHistogram = new JMenu();
	private JMenuItem jMenuHistoObserved = new JMenuItem();
	private JMenuItem jMenuHistoInfered = new JMenuItem();
	private JMenuItem jMenuHistoErrors = new JMenuItem();
	private JMenu jMenuXY = new JMenu();
	private JMenuItem jMenuXYInferedObserved = new JMenuItem();
	private JMenuItem jMenuXYErrorsObserved = new JMenuItem();
	private JMenuItem jMenuClassif = new JMenuItem();
	private JMenuItem jMenuDegAdequation =  new JMenuItem();
	private LinksItemsRules ItemsRules = new LinksItemsRules();
	//------------------------------------------------------------------------------
	private void SetTitleBorderResult() { this.titledBorderResult.setTitle(LocaleFIS.GetString("Results") + " (" + LocaleFIS.GetString("BlankThres") + "=" + this.jdfBlankThres.getValue() + ")" ); }
	//------------------------------------------------------------------------------
	public void Translate() throws Throwable
	{
		this.setTitle(LocaleFIS.GetString("Performance"));
		this.jBorderOutput.setTitle(LocaleFIS.GetString("Outputs"));
		this.jLabelBlankThres.setText(LocaleFIS.GetString("BlankThres"));
		this.jcbComputeLinks.setText(LocaleFIS.GetString("LinksBetweenRulesAndItems"));
		this.jbCompute.setText(LocaleFIS.GetString("Compute"));
		this.jLabelInferErrorClassif.setText(LocaleFIS.GetString("Error"));
		((TitledBorder)this.jPanelInferErrorRegression.getBorder()).setTitle(LocaleFIS.GetString("Error"));
		this.jLabelCoveradge.setText(LocaleFIS.GetString("Coveradge"));
		this.jLabelMaxError.setText(LocaleFIS.GetString("MaxError"));
		this.SetTitleBorderResult();
		this.jMenuSaveAs.setText(LocaleFIS.GetString("SaveAs"));
		this.jMenuResults.setText(LocaleFIS.GetString("Results"));
		this.jMenuViewResults.setText(LocaleFIS.GetString("View"));
		this.jMenuHistogram.setText(LocaleFIS.GetString("Histogram"));
		this.jMenuHistoObserved.setText(LocaleFIS.GetString("observed"));
		this.jMenuHistoInfered.setText(LocaleFIS.GetString("infered"));
		this.jMenuHistoErrors.setText(LocaleFIS.GetString("errors"));
		this.jMenuXY.setText("XY");
		this.jMenuXYInferedObserved.setText(LocaleFIS.GetString("InferedObserved"));
		this.jMenuXYErrorsObserved.setText(LocaleFIS.GetString("ErrorsObserved"));
		this.jMenuClassif.setText(LocaleFIS.GetString("Classif"));
		this.jMenuDegAdequation.setText(LocaleFIS.GetString("DegAdequation"));
		
		double value = this.jdfBlankThres.getValue();
		this.jdfBlankThres.setLocale(LocaleFIS.Locale());
		this.jdfBlankThres.setValue(value);
		this.repaint();
	}
	//------------------------------------------------------------------------------
	public JPerformanceFrame( JFISFrame parent, JFIS fis, JExtendedDataFile data_file, JSemaphore open )
	{
		super(parent);
		this.fis = fis;
		this.DataFile = data_file;
		this.JPerformanceFrameOpen = open;
		try { jbInit(); this.JPerformanceFrameOpen.Acquire(); }
		catch(Throwable t) { MessageFIS.Error(null, t); }
	}
	//------------------------------------------------------------------------------
	private void jbInit() throws Throwable
	{
		this.getContentPane().setLayout(new GridBagLayout());

		// menu
		this.jMenuBar.add(this.jMenuResults);
		this.jMenuResults.add(this.jMenuSaveAs);
		this.jMenuResults.add(this.jMenuViewResults);
		this.jMenuViewResults.add(this.jMenuHistogram);
		this.jMenuHistogram.add(this.jMenuHistoObserved);
		this.jMenuHistogram.add(this.jMenuHistoInfered);
		this.jMenuHistogram.add(this.jMenuHistoErrors);
		this.jMenuViewResults.add(this.jMenuXY);
		this.jMenuXY.add(this.jMenuXYInferedObserved);
		this.jMenuXY.add(this.jMenuXYErrorsObserved);
		this.jMenuViewResults.add(this.jMenuClassif);
		this.jMenuViewResults.add(this.jMenuDegAdequation);
		this.setJMenuBar(this.jMenuBar);

		this.PerfFile = new PerformanceFile[this.fis.NbOutputs()];
		for( int i=0 ; i<this.PerfFile.length ; i++ )
			this.PerfFile[i] = null;
		this.NbInputs = this.fis.NbInputs();

		// fichiers resultats
		this.result_file = new JMoveFile[this.fis.NbOutputs()];
		for( int i=0 ; i<this.result_file.length ; i++ )
		{
			File temp_file = File.createTempFile("performance", "result");
			this.result_file[i] = new JMoveFile(temp_file.getAbsolutePath());
		}

		// frames
		this.jFrameXYErrorObserved = new InferedDataXYFrame[this.fis.NbOutputs()];
		this.jFrameXYInferedObserved = new InferedDataXYFrame[this.fis.NbOutputs()];
		this.jFrameHistoInfered = new DataHistogramInputFrame[this.fis.NbOutputs()];
		this.jFrameHistoObserved = new DataHistogramInputFrame[this.fis.NbOutputs()];
		this.jFrameHistoError = new DataHistogramFrame[this.fis.NbOutputs()];
		this.jFrameClassifInf = new JClassifInfFrame[this.fis.NbOutputs()];
		this.jFrameAdequation = new JAdequationFrame[this.fis.NbOutputs()];

		// panel sortie
		this.InitOutputsRadioButtons();

		// panel parametres
		JPanel jPanelParameters = new JPanel(new GridBagLayout());
		jPanelParameters.add(this.jLabelBlankThres,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
		this.jdfBlankThres.setValue(0.1);
		jPanelParameters.add(this.jdfBlankThres,  new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
				,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 50, 0));
		jcbComputeLinks.setSelected(this.DataFile.ItemCount() < 200);
		jPanelParameters.add(this.jcbComputeLinks,  new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
				,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 50, 0));
		jPanelParameters.add(this.jbCompute,  new GridBagConstraints(0, 3, 2, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 50, 0));
		this.getContentPane().add(jPanelParameters,  new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));

		// panel resultats
		this.titledBorderResult = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(134, 134, 134)),"");
		jPanelResult.setBorder(this.titledBorderResult);
		jPanelResult.add(this.jLabelInferErrorClassif, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
				,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.jdfInferErrorClassif.setEditable(false);
		jPanelResult.add(this.jdfInferErrorClassif, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
				,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 0, 0), 40, 0));
		jPanelResult.add(this.jPanelInferErrorRegression, new GridBagConstraints(0, 0, 3, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		jPanelResult.add(this.jLabelCoveradge, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
				,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
		this.jdfCoveradge.setEditable(false);
		jPanelResult.add(this.jdfCoveradge, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
				,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 0), 40, 0));
		jPanelResult.add(new JLabel("%"), new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 0), 0, 0));
		jPanelResult.add(this.jLabelMaxError, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
				,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 0, 0));
		this.jdfMaxError.setEditable(false);
		jPanelResult.add(this.jdfMaxError, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
				,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 0, 0), 40, 0));
		this.getContentPane().add(jPanelResult,  new GridBagConstraints(0, 2, 2, 1, 1.0, 1.0
				,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
		this.showError();
		
		// events
		this.JFileListener = new JExtendedFileListener()
		{
			public void Closed()    { JPerformanceFrame.this.dispose(); }
			public void ReLoaded()  { JPerformanceFrame.this.ComputeOutputs(); }
			public void ActivationChanged(int item, boolean active) { JPerformanceFrame.this.ComputeOutputs(); }
			public void ActivationChanged(int []items, boolean active) { JPerformanceFrame.this.ComputeOutputs(); }
		};
		this.DataFile.AddJFileListener(this.JFileListener);
		this.jbCompute.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { JPerformanceFrame.this.ComputeOutputs(); }} );
		this.FISListener = new FISListener()
		{
			public void FISClosed()                               { JPerformanceFrame.this.dispose(); }
			public void InputReplaced( int input_number )         { JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputReplaced( int output_number )       { JPerformanceFrame.this.CloseInvalidFrames(output_number); JPerformanceFrame.this.ComputeOutputs(); }
			public void InputActiveChanged( int input_number )
			{
				try
				{
					if( JPerformanceFrame.this.fis.NbActiveInputs() == 0 ) JPerformanceFrame.this.dispose();
					JPerformanceFrame.this.ComputeOutputs();
				}
				catch( Throwable t ) {}
			}
			public void OutputActiveChanged( int output_number )
			{
				try
				{
					if( JPerformanceFrame.this.fis.NbActiveOutputs() == 0 ) JPerformanceFrame.this.dispose();
					JPerformanceFrame.this.InitOutputsRadioButtons();
					JPerformanceFrame.this.validate();
					JPerformanceFrame.this.repaint();
				}
				catch( Throwable t ) {}
			}
			public void InputNameChanged( int input_number ) {}
			public void OutputNameChanged( int output_number )    { try { JPerformanceFrame.this.InitOutputsRadioButtons(); JPerformanceFrame.this.validate(); JPerformanceFrame.this.repaint(); } catch( Throwable t ) {} }
			public void InputRangeChanged( int input_number )     { JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputRangeChanged( int output_number )   { JPerformanceFrame.this.ComputeOutputs(); }
			public void InputRemoved( int input_number ) {}
			public void OutputRemoved( int output_number ) {}
			public void InputAdded( int input_number ) {}
			public void OutputAdded( int output_number ) {}
			public void MFRemovedInInput( int input_number )      { JPerformanceFrame.this.ComputeOutputs(); }
			public void MFRemovedInOutput( int output_number )    { JPerformanceFrame.this.ComputeOutputs(); }
			public void MFAddedInInput( int input_number ) {}
			public void MFAddedInOutput( int output_number ) {}
			public void MFReplacedInInput( int input_number )     { JPerformanceFrame.this.ComputeOutputs(); }
			public void MFReplacedInOutput( int output_number )   { JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputDefuzChanged( int output_number )   { JPerformanceFrame.this.CloseInvalidFrames(output_number); JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputImpliChanged( int output_number )   { JPerformanceFrame.this.CloseInvalidImpliFrames(output_number); }
			public void OutputDisjChanged( int output_number )    { JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputClassifChanged( int output_number ) { JPerformanceFrame.this.CloseInvalidFrames(output_number); JPerformanceFrame.this.ComputeOutputs(); JPerformanceFrame.this.showError(); }
			public void OutputDefaultChanged( int output_number ) { JPerformanceFrame.this.ComputeOutputs(); }
			public void OutputAlarmThresChanged( int output_number ) {}
			public void RulesModified()
			{
				try
				{
					if( JPerformanceFrame.this.fis.NbActiveRules() == 0 ) JPerformanceFrame.this.dispose();
					JPerformanceFrame.this.ComputeOutputs();
				}
				catch( Throwable t ) {}
			}
			public void ConjunctionChanged() { JPerformanceFrame.this.ComputeOutputs(); }
		};
		this.fis.AddFISListener(this.FISListener);
		this.jMenuViewResults.addMenuListener(new MenuListener()
		{
			public void menuSelected(MenuEvent e) { jMenuViewResults_menuSelected(e); }
			public void menuDeselected(MenuEvent e) {}
			public void menuCanceled(MenuEvent e) {}
		});
		this.jMenuHistogram.addMenuListener(new MenuListener()
		{
			public void menuSelected(MenuEvent e) { jMenuHistogram_menuSelected(e); }
			public void menuDeselected(MenuEvent e) {}
			public void menuCanceled(MenuEvent e) {}
		});
		this.jMenuHistoInfered.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuHistoInfered_actionPerformed(e); }} );
		this.jMenuHistoObserved.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuHistoObserved_actionPerformed(e); }} );
		this.jMenuHistoErrors.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuHistoErrors_actionPerformed(e); }} );
		this.jMenuXYInferedObserved.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuXYInferedObserved_actionPerformed(e); }} );
		this.jMenuXYErrorsObserved.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuXYErrorsObserved_actionPerformed(e); }} );
		this.jMenuClassif.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuClassif_actionPerformed(e); }} );
		this.jMenuDegAdequation.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuDegAdequation_actionPerformed(e); }} );
		this.jMenuSaveAs.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { jMenuSaveAs_actionPerformed(e); }} );

		// Infere les sorties et calcul des liens
		this.ComputeOutputs();

		// affichage
		this.Translate();
		this.pack();
		this.setLocation(this.ChildPosition(this.getSize()));
		this.setVisible(true);
	}
	
	private void showError() {
		try {
			boolean classif = OutputClassif(this.fis.GetOutput(this.InferedOutput));
			this.jLabelInferErrorClassif.setVisible(classif);
			this.jdfInferErrorClassif.setVisible(classif);
			this.jPanelInferErrorRegression.setVisible(!classif);
			this.pack();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	//pour le passage sortie implicative-conjonctive et vice versa
    	//------------------------------------------------------------------------------
	/**
	 * Ferme toutes les fenetres de performance
	 */
	private void CloseInvalidImpliFrames( int output_number )
	{
	    if( JPerformanceFrame.this.jFrameAdequation[output_number] != null ) JPerformanceFrame.this.jFrameAdequation[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameHistoInfered[output_number] != null ) JPerformanceFrame.this.jFrameHistoInfered[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameHistoObserved[output_number] != null ) JPerformanceFrame.this.jFrameHistoObserved[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameHistoError[output_number] != null ) JPerformanceFrame.this.jFrameHistoError[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameXYErrorObserved[output_number] != null ) JPerformanceFrame.this.jFrameXYErrorObserved[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameXYInferedObserved[output_number] != null ) JPerformanceFrame.this.jFrameXYInferedObserved[output_number].dispose();
	    if( JPerformanceFrame.this.jFrameClassifInf[output_number] != null ) JPerformanceFrame.this.jFrameClassifInf[output_number].dispose();
		
	}
	//------------------------------------------------------------------------------
	/**
	 * Ferme les fenetres qui ne respectent pas le critere defini dans #OutputClassif\n
	 * les fenetres non classif sont fermees si la sortie est classif
	 */
	private void CloseInvalidFrames( int output_number )
	{
		try
		{
			JOutput output = JPerformanceFrame.this.fis.GetOutput(output_number);
			if( JPerformanceFrame.this.OutputClassif(output) == true )
			{
				// la sortie est devenue classif, on ferme les fenetres non classif sur cette sortie
				if( JPerformanceFrame.this.jFrameHistoInfered[output_number] != null ) JPerformanceFrame.this.jFrameHistoInfered[output_number].dispose();
				if( JPerformanceFrame.this.jFrameHistoObserved[output_number] != null ) JPerformanceFrame.this.jFrameHistoObserved[output_number].dispose();
				if( JPerformanceFrame.this.jFrameHistoError[output_number] != null ) JPerformanceFrame.this.jFrameHistoError[output_number].dispose();
				if( JPerformanceFrame.this.jFrameXYErrorObserved[output_number] != null ) JPerformanceFrame.this.jFrameXYErrorObserved[output_number].dispose();
				if( JPerformanceFrame.this.jFrameXYInferedObserved[output_number] != null ) JPerformanceFrame.this.jFrameXYInferedObserved[output_number].dispose();
				
			}
	
				
		}
		catch( Throwable t ) {}
	}
	//------------------------------------------------------------------------------
	public void dispose()
	{
		super.dispose();
		for( int i=0 ; i<this.PerfFile.length ; i++ )
			if( this.PerfFile[i] != null )
				this.PerfFile[i].Close();
		this.DataFile.RemoveJFileListener(this.JFileListener);
		this.fis.RemoveFISListener(this.FISListener);
		this.JPerformanceFrameOpen.Release();
		if( this.result_file != null)
			for( int i=0 ; i< this.result_file.length ; i++ )
				if( this.result_file[i] != null )
				{
					(new File(this.result_file[i].getAbsolutePath())).delete();
					(new File(this.result_file[i].getAbsolutePath() + JExtendedDataFile.InactiveExtension)).delete();
				}
	}
	//------------------------------------------------------------------------------
	public void InitOutputsRadioButtons() throws Throwable
	{
		if( this.jPanelOutput != null )
			this.getContentPane().remove(this.jPanelOutput);
		this.jPanelOutput = new JPanel(new GridBagLayout());
		this.jBorderOutput = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(134, 134, 134)),"");
		this.jBorderOutput.setTitle(LocaleFIS.GetString("Outputs"));
		this.jPanelOutput.setBorder(this.jBorderOutput);
		this.jbgOutput = new ButtonGroup();
		for( int i=0 ; i<this.fis.NbOutputs() ; i++ )
		{
			final int output_number = i;
			JRadioButton jrb = new JRadioButton(this.fis.GetOutput(i).GetName());
			jrb.setEnabled(this.fis.GetOutput(i).GetActive());
			jrb.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e)
			{
				JPerformanceFrame.this.OutputSelected = output_number;
				JPerformanceFrame.this.ComputeOutputs();
			} } );

			if( output_number == 0 )  // selectionne par defaut la premiere sortie
			{
				this.OutputSelected = output_number;
				jrb.setSelected(true);
			}
			jbgOutput.add(jrb);
			this.jPanelOutput.add(jrb, new GridBagConstraints(0, i, 1, 1, 0.0, 0.0
					,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 0, 0, 0), 0, 0));
		}
		this.getContentPane().add(jPanelOutput,   new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
				,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 5, 5), 0, 0));
	}
	//------------------------------------------------------------------------------
	private void ComputeOutputs()
	{
		File f = null;
		try
		{
			// modif titre resultats
			this.SetTitleBorderResult();
			// calcul des liens
			this.ItemsRules.reset();
			if(this.jcbComputeLinks.isSelected()) { 
				f = File.createTempFile("links", null); 
				this.fis.Links(this.DataFile, 1e-6, false, f.getAbsolutePath(), this.ItemsRules ) ;
				(new File(f.getAbsolutePath()+"."+jnifis.LinksItemsRulesExtension())).delete();
				(new File(f.getAbsolutePath()+"."+jnifis.LinksRulesItemsExtension())).delete();
				(new File(f.getAbsolutePath()+"."+jnifis.LinksRulesLinksExtension())).delete();
			}
			// recalcule les sorties non selectionnees qui ont des fenetres de visualistion ouvertes
			for( int i=0 ; i<this.fis.NbOutputs() ; i++ )
				if( (this.PerfFile[i] != null) && (i != this.OutputSelected) )
					if( this.PerfFile[i].ListenersSize() != 0 )
						this.Compute(i);
			// recalcule la sortie selectionnee
			this.Compute(this.OutputSelected);
		}
		catch( Throwable t ) { MessageFIS.Error(null, t); }
		finally {  /*f.delete();*/  }
	}
	//------------------------------------------------------------------------------
	private void Compute( int output_number ) throws Throwable
	{
		try
		{
			this.InferedOutput = -1;
			JOutput output = this.fis.GetOutput(output_number);
			if( output.GetActive() == false )
			{
				MessageFIS.Error(this, "", output.GetName() + " " + LocaleFIS.GetString("IsNotActive"));
				return;
			}
			else
			{
				double [] result = this.fis.Infer(output_number, this.DataFile.ActiveFileName(), this.result_file[output_number].getAbsolutePath(), this.jdfBlankThres.getValue(), false);
				File f = new File(this.result_file[output_number].getAbsolutePath() + JExtendedDataFile.InactiveExtension);
				f.delete();
				f = new File(this.DataFile.InactiveFileName());
				if( f.exists() && !this.OutputClassif(this.fis.GetOutput(output_number)) )
					this.fis.Infer(output_number, this.DataFile.InactiveFileName(), this.result_file[output_number].getAbsolutePath() + JExtendedDataFile.InactiveExtension, this.jdfBlankThres.getValue(), false);

				this.PerfResult = result[0];
				if( this.PerfResult != -2 )
					this.InferedOutput = output_number;
				this.jdfInferErrorClassif.setValue(result[0]);
				this.jPanelInferErrorRegression.setValues(this.fis.InferErrorRegression());
				this.jdfCoveradge.setValue((int)(result[1]*100));
				this.jdfMaxError.setValue(result[2]);
				if( this.PerfFile[output_number] == null )
					this.PerfFile[output_number] = new PerformanceFile(this.result_file[output_number].getAbsolutePath());
				else
					this.PerfFile[output_number].Reload(this.result_file[output_number].getAbsolutePath());
			}
		}
		catch( Throwable t )
		{
			this.InferedOutput = -1;
			if(!this.fis.GetOutput(output_number).GetImplicatif()) MessageFIS.Error(null, t); //A modifier + tard + throws Throwable a enlever
		}
		this.validate();
		this.repaint();
	}
	//------------------------------------------------------------------------------
	/**
	 * Type de sortie
	 * @return true si classif, false sinon
	 */
	private boolean OutputClassif( JOutput output ) throws Throwable { return (output.GetClassif() == true) && (output.GetNature() == JOutput.CRISP) && ((output.GetDefuz() == JOutput.DEFUZ_CRISP_SUGENO) || (output.GetDefuz() == JOutput.DEFUZ_CRISP_MAXCRISP)); }
	private boolean OutputImplicatifObs( JOutput output ) throws Throwable { return (output.GetImplicatif() == true) && (this.PerfResult != -1); }
	
	//------------------------------------------------------------------------------
	void jMenuViewResults_menuSelected(MenuEvent e)
	{
		if( this.InferedOutput == -1 )  // aucune sortie n'a ete inferee, ou erreur lors du calcul
		{
			this.jMenuHistogram.setEnabled(false);
			this.jMenuXY.setEnabled(false);
			this.jMenuClassif.setEnabled(false);
			this.jMenuDegAdequation.setEnabled(false);
		}
		else
		{
			try
			{
				JOutput output = this.fis.GetOutput(this.InferedOutput);
				if( this.OutputClassif(output) == true ) // la sortie inferee est de type classif
				{
					this.jMenuHistogram.setEnabled(false);
					this.jMenuXY.setEnabled(false);
					this.jMenuClassif.setEnabled(true);
				}
				else
				{
					this.jMenuHistogram.setEnabled(true);
					if( this.PerfResult == -1 ) // il n'y a pas de sorties observees
						this.jMenuXY.setEnabled(false);
					else
						this.jMenuXY.setEnabled(true);
					this.jMenuClassif.setEnabled(false);
				}
				//la sortie est de type implicatif et val obs
				if( this.OutputImplicatifObs(output) == false)
					this.jMenuDegAdequation.setEnabled(false);
				else this.jMenuDegAdequation.setEnabled(true);
			}
			catch( Throwable t ) {}
		}
	}
	//------------------------------------------------------------------------------
	void jMenuHistogram_menuSelected(MenuEvent e)
	{
		if( this.PerfResult == -1 ) // il n'y a pas de sorties observees
		{
			this.jMenuHistoObserved.setEnabled(false);
			this.jMenuHistoErrors.setEnabled(false);
		}
		else
		{
			this.jMenuHistoObserved.setEnabled(true);
			this.jMenuHistoErrors.setEnabled(true);
		}
	}
	//------------------------------------------------------------------------------
	void jMenuHistoInfered_actionPerformed(ActionEvent e)
	{
		try
		{
			if( (this.jFrameHistoInfered[this.OutputSelected] == null) || (this.jFrameHistoInfered[this.OutputSelected].IsOpen() == false) )
				this.jFrameHistoInfered[this.OutputSelected] = new DataHistogramInputFrame(this.parent, this.fis, this.NbInputs+this.InferedOutput, this.PerfFile[this.InferedOutput].IndexInferred(), this.PerfFile[this.InferedOutput] )
			{
				public void setTitle(String title) { super.setTitle(title + " " + LocaleFIS.GetString("infered") ); }
			};
			else
				this.jFrameHistoInfered[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) {}
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuHistoObserved_actionPerformed(ActionEvent e)
	{
		try
		{
			if( (this.jFrameHistoObserved[this.OutputSelected] == null) || (this.jFrameHistoObserved[this.OutputSelected].IsOpen() == false) )
				this.jFrameHistoObserved[this.OutputSelected] = new DataHistogramInputFrame(this.parent, this.fis, this.NbInputs+this.InferedOutput, this.PerfFile[this.InferedOutput].IndexObserved(), this.PerfFile[this.InferedOutput] )
			{
				public void setTitle(String title) { super.setTitle(title + " " + LocaleFIS.GetString("observed") ); }
			};
			else
				this.jFrameHistoObserved[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuHistoErrors_actionPerformed(ActionEvent e)
	{
		try
		{
			if( (this.jFrameHistoError[this.OutputSelected] == null) || (this.jFrameHistoError[this.OutputSelected].IsOpen() == false) )
				this.jFrameHistoError[this.OutputSelected] = new DataHistogramFrame(this.parent, this.fis.GetOutput(this.InferedOutput).GetName(), this.PerfFile[this.InferedOutput].IndexError(), this.PerfFile[this.InferedOutput] )
			{
				public void setTitle(String title) { super.setTitle(title + " " + LocaleFIS.GetString("errors") ); }
			};
			else
				this.jFrameHistoError[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuXYInferedObserved_actionPerformed(ActionEvent e)
	{
		try
		{
			int fis_index = this.NbInputs + this.InferedOutput;
			if( (this.jFrameXYInferedObserved[this.OutputSelected] == null) || (this.jFrameXYInferedObserved[this.OutputSelected].IsOpen() == false) )
			{
			    // implicative case
			    
				this.jFrameXYInferedObserved[this.OutputSelected] = new InferedDataXYFrame(this.parent, fis_index, fis_index, this.fis, this.PerfFile[this.InferedOutput].IndexObserved(), this.PerfFile[this.InferedOutput].IndexInferred(), this.PerfFile[this.InferedOutput], this.DataFile, this.result_file[this.OutputSelected].getAbsolutePath() + JExtendedDataFile.InactiveExtension, this.ItemsRules)
				{
					protected String GetXLabel() throws Throwable { return super.GetXLabel() + " " + LocaleFIS.GetString("observed"); }
					protected String GetYLabel() throws Throwable { return super.GetYLabel() + " " + LocaleFIS.GetString("infered"); }
					protected XYPanel CreateXYPanel( JInput x_input, double [] x_data, JInput y_input, double [] y_data ) throws Throwable
					{
						XYPanel panel = super.CreateXYPanel(x_input, x_data, y_input, y_data);
						panel.ShowRegression(true);
						return panel;
					}
				};
			}
			else
				this.jFrameXYInferedObserved[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuXYErrorsObserved_actionPerformed(ActionEvent e)
	{
		try
		{
			int fis_index = this.NbInputs + this.InferedOutput;
			if( (this.jFrameXYErrorObserved[this.OutputSelected] == null) || (this.jFrameXYErrorObserved[this.OutputSelected].IsOpen() == false) )
			{
				this.jFrameXYErrorObserved[this.OutputSelected] = new InferedDataXYFrame(this.parent, fis_index, -1, this.fis, this.PerfFile[this.InferedOutput].IndexObserved(), this.PerfFile[this.InferedOutput].IndexError(), this.PerfFile[this.InferedOutput], this.DataFile, this.result_file[this.OutputSelected].getAbsolutePath() + JExtendedDataFile.InactiveExtension, this.ItemsRules )
				{
					protected String GetXLabel() throws Throwable { return super.GetXLabel() + " " + LocaleFIS.GetString("observed"); }
					protected String GetYLabel() throws Throwable { return LocaleFIS.GetString("errors"); }
				};
			}
			else
				this.jFrameXYErrorObserved[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuClassif_actionPerformed(ActionEvent e)
	{
		try
		{
			if( (this.jFrameClassifInf[this.OutputSelected] == null) || (this.jFrameClassifInf[this.OutputSelected].IsOpen() == false) )
			{
				if( this.PerfResult == -1 )  // pas de sorties observees
					this.jFrameClassifInf[this.OutputSelected] = new JClassifInfFrame(this.parent, this.InferedOutput, this.fis, this.PerfFile[this.InferedOutput].IndexClassInferred(), this.PerfFile[this.InferedOutput]);
				else
					this.jFrameClassifInf[this.OutputSelected] = new JClassifInfObsFrame(this.parent, this.InferedOutput, this.fis, this.PerfFile[this.InferedOutput].IndexClassInferred(), this.PerfFile[this.InferedOutput].IndexObserved(), this.PerfFile[this.InferedOutput]);
			}
			else
				this.jFrameClassifInf[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuDegAdequation_actionPerformed(ActionEvent e) 
	{
		try
		{
			if( (this.jFrameAdequation[this.OutputSelected] == null) || (this.jFrameAdequation[this.OutputSelected].IsOpen() == false) )
			{
				this.jFrameAdequation[this.OutputSelected] = new JAdequationFrame(this.parent, this.InferedOutput, this.fis, this.PerfFile[this.InferedOutput].IndexObserved(), this.PerfFile[this.InferedOutput].IndexInferredSymbMatch(), this.PerfFile[this.InferedOutput]);
			}
			else
				this.jFrameAdequation[this.OutputSelected].setVisible(true);
		}
		catch( Throwable t ) { MessageFIS.Error(null,t); }
		this.repaint();
	}
	//------------------------------------------------------------------------------
	void jMenuSaveAs_actionPerformed(ActionEvent e)
	{
		try
		{
			JFileChooser file_chooser = new JFileChooser(MainFIS.config.DataFilePath())
			{
				protected JDialog createDialog(Component parent) throws HeadlessException
				{
					JDialog dialog = super.createDialog(parent);
					dialog.setResizable(false);
					return dialog;
				}
			};
			file_chooser.setAcceptAllFileFilterUsed(true);
			file_chooser.setSelectedFile(new File(MainFIS.config.DataFilePath() + System.getProperty("file.separator") + "result"));
			if( file_chooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION )
			{
				String file_name = file_chooser.getSelectedFile().getAbsolutePath();

				// teste si le fichier existe
				File f = new File( file_name );
				if( f.exists() )
				{
					String message = LocaleFIS.GetString("TheFile") + file_name + " " + LocaleFIS.GetString("AlreadyExist") + "\n" + LocaleFIS.GetString("DoYouWantToReplaceIt");
					if( MessageFIS.Confirm(this, message) == JOptionPane.NO_OPTION )
						return;
				}

				// sauvegarde le fichier
				this.result_file[this.OutputSelected].MoveTo(file_name);
			}
		}
		catch( Throwable t ) { MessageFIS.Error( null, t ); }
	}
}




//------------------------------------------------------------------------------
class PerformanceFile extends JFile
{
	private Vector headers; /**< Vecteur des entetes du fichier performance */
	//------------------------------------------------------------------------------
	public PerformanceFile( String file_name ) throws Throwable { super(file_name); }
	//------------------------------------------------------------------------------
	protected double [][] LoadData() throws Throwable
	{
		this.headers = new Vector();
		// ouverture du fichier file_name
		File f = new File(this.FileName());
		// creation d'un buffer de lecture du fichier f
		BufferedReader br = new BufferedReader( new InputStreamReader( new FileInputStream(f) ) );
		String buffer;
		// lecture de l'entete du fichier performance
		buffer = br.readLine();
		StringTokenizer st = new StringTokenizer( buffer, " " );
		while( st.countTokens() != 0 )
			this.headers.add(new String(st.nextToken()));
		// lecture des donnees
		Vector vect_data = new Vector();
		while( (buffer = br.readLine()) != null ) // tant que le fichier n'est pas entierement lu
		{
			st = new StringTokenizer( buffer, " " );
			Vector v = new Vector();
			while( st.countTokens() != 0 )
				v.add(new Double(st.nextToken()));
			vect_data.add(v);
		}
		// copie du vecteur dans le tableau Data
		double [][] Data = new double [vect_data.size()] [];
		for( int i=0 ; i<Data.length ; i++ )
		{
			Vector v = (Vector)vect_data.elementAt(i);
			Data[i] = new double [v.size()];
			for( int j=0 ; j<v.size() ; j++ )
				Data[i][j] = ((Double)v.elementAt(j)).doubleValue();
		}
		return Data;
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des donnees observees dans le fichier performance
	 * @return numero de la colonne contenant les donnees observees
	 */
	public int IndexObserved() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderObserved()) == true )
				return i;
		throw new Exception("No observed column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des donnees inferees dans le fichier performance
	 * @return numero de la colonne contenant les donnees inferees
	 */
	public int IndexInferred() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderInferred()) == true )
				return i;
		throw new Exception("No inferred column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des donnees erreurs dans le fichier performance
	 * @return numero de la colonne contenant les donnees erreurs
	 */
	public int IndexError() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderError()) == true )
				return i;
		throw new Exception("No error column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des donnees classes inferees dans le fichier performance
	 * @return numero de la colonne contenant les donnees classes inferees
	 * modif bch 15 decembre 06 : ou numero colonne v.inferees (cas maxcrisp)
	 */
	public int IndexClassInferred() throws Throwable
	{
		int i;
		for( i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderClassInferred()) == true )
				return i;
		for( i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderInferred()) == true )
				return i;
		throw new Exception("No class inferred column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des exemples blanc dans le fichier performance
	 * @return numero de la colonne contenant les exemples blanc
	 */
	public int IndexBlank() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderBlank()) == true )
				return i;
		throw new Exception("No blank column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des exemples blanc dans le fichier performance
	 * @return numero de la colonne contenant les exemples blanc
	 */
	public int IndexMinKernel() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderMinKernel()) == true )
				return i;
		throw new Exception("No min kernel column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des exemples blanc dans le fichier performance
	 * @return numero de la colonne contenant les exemples blanc
	 */
	public int IndexMaxKernel() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderMaxKernel()) == true )
				return i;
		throw new Exception("No max kernel column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des exemples blanc dans le fichier performance
	 * @return numero de la colonne contenant les exemples blanc
	 */
	public int IndexMinSupport() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderMinSupport()) == true )
				return i;
		throw new Exception("No min support column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des exemples blanc dans le fichier performance
	 * @return numero de la colonne contenant les exemples blanc
	 */
	public int IndexMaxSupport() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderMaxSupport()) == true )
				return i;
		throw new Exception("No max support column in file " + this.FileName());
	}
	//------------------------------------------------------------------------------
	/**
	 * Index des match dans le fichier performance
	 * @return numero de la colonne contenant match
	 */
	public int IndexInferredSymbMatch() throws Throwable
	{
		for( int i=0 ; i<this.headers.size() ; i++ )
			if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderInferredSymbMatch()) == true )
				return i;
		throw new Exception("No Inferred Symb Match column in file " + this.FileName());
	}
    //------------------------------------------------------------------------------
	/**
	   test implicative output
	  	 */
    public boolean IsPerfFileImpli() throws Throwable
    {
	for( int i=0 ; i<this.headers.size() ; i++ )
	    if( ((String)this.headers.elementAt(i)).equals(jnifis.PerfHeaderMinKernel()) == true )
		return true;
	return false;
    }
}

