//***********************************************************************
//
//                              JRule.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

//------------------------------------------------------------------------------
public class JRule
{
  private long ptr;
//------------------------------------------------------------------------------
  public JRule( long ptr ) throws Throwable { this.ptr = ptr; }
//------------------------------------------------------------------------------
  public int [] Facteurs() throws Throwable { return jnifis.GetRuleProps(this.ptr); }
//------------------------------------------------------------------------------
  public double [] Actions() throws Throwable { return jnifis.GetRuleConcs(this.ptr); }
//------------------------------------------------------------------------------
  public boolean GetActive() throws Throwable { return jnifis.GetRuleActive(this.ptr); }
//------------------------------------------------------------------------------
  public void SetActive( boolean active ) throws Throwable { jnifis.SetRuleActive(this.ptr, active); }
//------------------------------------------------------------------------------
  public double Poids() throws Throwable { return jnifis.RulePoids(this.ptr); }
//------------------------------------------------------------------------------
  public void SetExpertWeight( double weight ) throws Throwable { jnifis.SetExpertWeight(ptr, weight); }
//------------------------------------------------------------------------------
  public double GetExpertWeight() throws Throwable { return jnifis.GetExpertWeight(ptr); }
//------------------------------------------------------------------------------
  public long Ptr() { return this.ptr; }
//------------------------------------------------------------------------------
  public void Delete()
  {
  try { jnifis.DeleteRule(this.ptr); }
  catch( Throwable t ) {}
  }
//------------------------------------------------------------------------------
  public boolean PremisseEqual( JRule rule ) throws Throwable { return jnifis.RulePremisseEqual(this.ptr, rule.Ptr()); }
//------------------------------------------------------------------------------
  public void SetProp( int input_number, int prop ) throws Throwable { jnifis.SetRuleProp(this.ptr, input_number, prop); }
//------------------------------------------------------------------------------
  public void SetConc( int output_number, double conc ) throws Throwable { jnifis.SetRuleConc(this.ptr, output_number, conc); }
}