//***********************************************************************
//
//                              LinksItemsRules.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.util.*;
import java.io.*;

public class LinksItemsRules {

  private Vector RulesVector ;

  public LinksItemsRules() {}

//------------------------------------------------------------------------------

public void LoadFile(String new_name)
{
   BufferedReader br = null;
   try
     {
     File resultfile = new File(new_name);
     String str;
     RulesVector = new Vector() ;
     br = new BufferedReader(new FileReader(resultfile)) ; //to read the file
     while ( (str = br.readLine()) != null)
     {
       try{ RulesVector.add( (new String(str.substring(3)))); }
       catch (Throwable t) {RulesVector.add(new String(LocaleFIS.GetString("NoActivatedRules")));}
     }
    } catch (IOException e) { MessageFIS.Error(null, e); }
    finally{ try{ if( br!= null) br.close(); } catch (IOException e) { MessageFIS.Error(null, e); } }

}
//------------------------------------------------------------------------------
public String GetRules (int example_number)
  {
    return this.RulesVector != null ? (String)(this.RulesVector.elementAt(example_number)) : new String() ;
  }

//------------------------------------------------------------------------------
public void reset() {
	this.RulesVector = null;
}

}
