//***********************************************************************
//
//                              LocaleFIS.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.util.*;
import javax.swing.*;

//------------------------------------------------------------------------------
public class LocaleFIS
{
  private static Locale locale;
  private static ResourceBundle captions;
//------------------------------------------------------------------------------
  public LocaleFIS( String language, String country )
  {
  // creation de la localisation
  locale = new Locale( language, country );
  locale.setDefault(locale);
  // recherche du fichier de resources
  captions = ResourceBundle.getBundle( "resources.Messages", locale );
  // traduction de la boite de dialogue JOptionPane
  UIManager.put("OptionPane.yesButtonText", LocaleFIS.GetString("Yes"));
  UIManager.put("OptionPane.noButtonText", LocaleFIS.GetString("No"));
  UIManager.put("OptionPane.cancelButtonText", LocaleFIS.GetString("Cancel"));
  }
//------------------------------------------------------------------------------
  public static String DefaultLanguage() { return "en"; }
//------------------------------------------------------------------------------
  public static String DefaultCountry() { return "GB"; }
//------------------------------------------------------------------------------
  public static Locale Locale() { return LocaleFIS.locale; }
//------------------------------------------------------------------------------
  public String Language() { return this.captions.getLocale().getLanguage(); }
//------------------------------------------------------------------------------
  public static String GetString( String s )
  {
  if( (locale == null) || (captions == null ) )
    return s;
  try { return captions.getString( s ); }
  catch( MissingResourceException e )
    {
    // la chaine n'a pas ete trouvee
    String title;
    String message;
    try { title = captions.getString( "Error" ); }
    catch( MissingResourceException e1 ) { title = "Error"; }
    try { message = s + " " + captions.getString( "NotFoundInResourceFile" ) + " " + locale.getDisplayName(); }
    catch( MissingResourceException e2 ) { message = s + " not found in resource file " + locale.getDisplayName(); }
    MessageFIS.Error( null, title, message );
    return s;
    }
  }
//------------------------------------------------------------------------------
  public static String GetStringNoException( String s )
  {
  if( (locale == null) || (captions == null ) )
    return s;
  try { return captions.getString( s ); }
  catch( MissingResourceException e ) {}
  return s;
  }
}



