package fis.data.distance;

import java.io.File;

import util.algorithm.distance.minkowski.Minkowski;

import com.google.common.collect.ImmutableList;
import com.jgoodies.common.bean.ObservableBean2;

import fis.data.distance.input.Input;

public interface Distance extends ObservableBean2 {

	static final String PROPERTY_NORMALIZE = "normalize";
	static final String PROPERTY_OUTPUT_FILE = "outputFile";

	static final String PROPERTY_MINKOWSKI_CHANGED = "minkowskiChanged";

	static final boolean DEFAULT_NORMALIZE = true;
	static final String DEFAULT_OUTPUT_FILE = "distance.out";

	Minkowski getMinkowski();

	ImmutableList<Input> getInputs();

	boolean isNormalize();

	void setNormalize(boolean normalize);

	File getOutputFile();

	void setOutputFile(File outputFile);
}
