package fis.data.distance;

import static java.awt.Cursor.DEFAULT_CURSOR;
import static java.awt.Cursor.WAIT_CURSOR;
import static util.swing.SwingUtilities.getWindowAncestor;
import static util.swing.WindowUtilities.setCursor;
import static util.swing.dialog.JOptionPaneFileExist.replaceFile;

import java.awt.event.ActionEvent;

import util.swing.action.performable.PerformableActionListener;
import fis.jnifis;
import fis.data.distance.jni.JNIDistance;

public class DistancePerformableAction implements PerformableActionListener {

	private final JNIDistance jniDistance;

	public DistancePerformableAction(JNIDistance jniDistance) {
		this.jniDistance = jniDistance;
	}

	@Override
	public boolean isActionPerformed(ActionEvent e) throws Throwable {
		if (jniDistance.getOutputFile().isFile() && !replaceFile(getWindowAncestor(e.getSource()), jniDistance.getOutputFile()))
			return false;
		setCursor(e.getSource(), WAIT_CURSOR);
		try {
			jnifis.DataDistance(jniDistance.getFISPtr(), jniDistance.getDataFileName(), jniDistance.isNormalize(), jniDistance.getInputDistances(), jniDistance.getPower(), jniDistance.getOutputFilePath());
		} catch (Exception exception) {
			throw exception;
		} finally {
			setCursor(e.getSource(), DEFAULT_CURSOR);
		}
		return true;
	}
}
