package fis.data.distance;

import util.algorithm.distance.minkowski.MinkowskiValidator;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;


public class DistanceValidator implements Validator<Distance> {

	private final MinkowskiValidator minkowskiValidator = new MinkowskiValidator();

	@Override
	public ValidationResult validate(Distance distance) {
		return validateMinkowski(distance);
	}

	private ValidationResult validateMinkowski(Distance distance) {
		return minkowskiValidator.validate(distance.getMinkowski());
	}
}
