package fis.data.distance.input;

import static org.apache.commons.lang.StringUtils.EMPTY;

import com.jgoodies.binding.beans.Model;

import fis.JInput;
import fis.input.distance.Distance;

@SuppressWarnings("serial")
public class InputModel extends Model implements Input {

	private final JInput input;
	private Distance distance = DEFAULT_DISTANCE;

	public InputModel(JInput input) {
		this.input = input;
	}

	@Override
	public String getName() {
		try {
			return input.GetName();
		} catch (Throwable e) {
			return EMPTY;
		}
	}

	@Override
	public Distance getDistance() {
		return distance;
	}

	@Override
	public void setDistance(Distance distance) {
		firePropertyChange(PROPERTY_DISTANCE, this.distance, this.distance = distance);
	}

	@Override
	public boolean isActive() {
		try {
			return input.GetActive();
		} catch (Throwable e) {
			return false;
		}
	}
}
