package fis.data.sample.block;

import java.beans.PropertyChangeEvent;

import util.jgoodies.common.bean.BeanChangeListener;
import util.jgoodies.common.bean.ObservableBean2ChangeSupport;

public abstract class BlockSampleChangeSupportDecorator extends BlockSampleDecorator implements BeanChangeListener {

	private final ObservableBean2ChangeSupport changeSupport;

	public BlockSampleChangeSupportDecorator(BlockSample blockSample) {
		super(blockSample);
		changeSupport = new ObservableBean2ChangeSupport(blockSample) {

			@Override
			public void beanChange(PropertyChangeEvent evt) {
				BlockSampleChangeSupportDecorator.this.beanChange(evt);
			}
		};
	}

	public void release() {
		changeSupport.release();
	}
}
