package fis.data.sample.block;

import java.util.Map;

import util.jgoodies.binding.beans.ModelCloner;

import com.jgoodies.binding.beans.Model;
import com.rits.cloning.Cloner;
import com.rits.cloning.IFastCloner;

@SuppressWarnings("serial")
public class BlockSampleModel extends Model implements BlockSample {

	private int number = DEFAULT_BLOCK_NUMBER;
	private boolean constantSize = true;

	@Override
	public int getNumber() {
		return number;
	}

	@Override
	public boolean isConstantSize() {
		return constantSize;
	}

	@Override
	public void setConstantSize(boolean constantSize) {
		firePropertyChange(PROPERTY_CONSTANT_SIZE, this.constantSize, this.constantSize = constantSize);
	}

	@Override
	public void setNumber(int number) {
		firePropertyChange(PROPERTY_NUMBER, this.number, this.number = number);
	}

	public static class FastCloner implements IFastCloner {

		@Override
		public Object clone(Object t, Cloner cloner, Map<Object, Object> clones) throws IllegalAccessException {
			return new ModelCloner().deepClone(t);
		}
	}
}
