package fis.data.sample.classif;

import static com.jgoodies.validation.Severity.ERROR;
import static com.jgoodies.validation.ValidationResult.EMPTY;
import static fis.LocaleFIS.GetString;
import static fis.data.sample.classif.ClassifSample.KEY_PRECISION;
import static fis.data.sample.classif.ClassifSample.LABEL_PRECISION;
import static util.jgoodies.validation.range.RangeUtils.atLeastValidator;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;

public class ClassifSampleValidator implements Validator<ClassifSample> {

	@Override
	public ValidationResult validate(ClassifSample classifSample) {
		return classifSample.isClassif() ? atLeastValidator(GetString(LABEL_PRECISION), ERROR, KEY_PRECISION, 0d).validate(classifSample.getPrecision()) : EMPTY;
	}
}
