package fis.data.sample.generator.jni.block;

import fis.JExtendedDataFile;
import fis.data.sample.generator.block.BlockSampleGenerator;
import fis.data.sample.generator.jni.JNISampleGenerator;

public class DefaultJNIBlockSampleGenerator implements JNISampleGenerator {

	private final JExtendedDataFile data;
	private final BlockSampleGenerator blockSampleGenerator;

	public DefaultJNIBlockSampleGenerator(JExtendedDataFile data, BlockSampleGenerator blockSampleGenerator) {
		this.data = data;
		this.blockSampleGenerator = blockSampleGenerator;
	}

	@Override
	public String getDataFileName() {
		return data.GetFileName();
	}

	@Override
	public int getSampleNumber() {
		return blockSampleGenerator.getBlockSample().getNumber();
	}

	@Override
	public double getLearningDataRatio() {
		return 0.5;
	}

	@Override
	public int getSeed() {
		return blockSampleGenerator.getSeed().getSeed();
	}

	@Override
	public boolean isClassif() {
		return blockSampleGenerator.getClassifSample().isClassif();
	}

	@Override
	public int getColumnNumber() {
		return blockSampleGenerator.getClassifSample().getClassifVariable();
	}

	@Override
	public double getPrecision() {
		return blockSampleGenerator.getClassifSample().getPrecision();
	}

	@Override
	public boolean isReplace() {
		return false;
	}

	@Override
	public boolean isTruncate() {
		return blockSampleGenerator.getBlockSample().isConstantSize();
	}
}
