package fis.data.sample.generator.jni.pair;

import fis.JExtendedDataFile;
import fis.data.sample.generator.jni.JNISampleGenerator;
import fis.data.sample.generator.pair.PairSampleGenerator;

public class DefaultJNIPairSampleGenerator implements JNISampleGenerator {

	private final JExtendedDataFile data;
	private final PairSampleGenerator pairSampleGenerator;

	public DefaultJNIPairSampleGenerator(JExtendedDataFile data, PairSampleGenerator pairSampleGenerator) {
		this.data = data;
		this.pairSampleGenerator = pairSampleGenerator;
	}

	@Override
	public String getDataFileName() {
		return data.FileName();
	}

	@Override
	public int getSampleNumber() {
		return pairSampleGenerator.getPairSample().getPairNumber();
	}

	@Override
	public double getLearningDataRatio() {
		return pairSampleGenerator.getPairSample().getLearningRatio();
	}

	@Override
	public int getSeed() {
		return pairSampleGenerator.getSeed().getSeed();
	}

	@Override
	public boolean isClassif() {
		return pairSampleGenerator.getClassifSample().isClassif();
	}

	@Override
	public int getColumnNumber() {
		return pairSampleGenerator.getClassifSample().getClassifVariable();
	}

	@Override
	public double getPrecision() {
		return pairSampleGenerator.getClassifSample().getPrecision();
	}

	@Override
	public boolean isReplace() {
		return true;
	}

	@Override
	public boolean isTruncate() {
		return false;
	}
}
