package fis.data.sample.generator.pair;

import static util.jgoodies.validation.ValidationUtils.validationResult;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;

import fis.data.sample.classif.ClassifSampleValidator;
import fis.data.sample.pair.PairSampleValidator;

public class PairSampleGeneratorValidator implements Validator<PairSampleGenerator> {

	private final PairSampleValidator pairSampleValidator = new PairSampleValidator();
	private final ClassifSampleValidator classifSampleValidator = new ClassifSampleValidator();

	@Override
	public ValidationResult validate(PairSampleGenerator pairSampleGenerator) {
		return validationResult(validatePairSample(pairSampleGenerator), validateClassifSample(pairSampleGenerator));
	}

	private ValidationResult validatePairSample(PairSampleGenerator pairSampleGenerator) {
		return pairSampleValidator.validate(pairSampleGenerator.getPairSample());
	}

	private ValidationResult validateClassifSample(PairSampleGenerator pairSampleGenerator) {
		return classifSampleValidator.validate(pairSampleGenerator.getClassifSample());
	}
}
