package fis.data.sample.pair;

import java.beans.PropertyChangeEvent;

import util.jgoodies.common.bean.BeanChangeListener;
import util.jgoodies.common.bean.ObservableBean2ChangeSupport;

public abstract class PairSampleChangeSupportDecorator extends PairSampleDecorator implements BeanChangeListener {

	private final ObservableBean2ChangeSupport changeSupport;

	public PairSampleChangeSupportDecorator(PairSample pairSample) {
		super(pairSample);
		changeSupport = new ObservableBean2ChangeSupport(pairSample) {

			@Override
			public void beanChange(PropertyChangeEvent evt) {
				PairSampleChangeSupportDecorator.this.beanChange(evt);
			}
		};
	}

	public void release() {
		changeSupport.release();
	}
}
