package fis.data.sample.pair;

import java.util.Map;

import util.jgoodies.binding.beans.ModelCloner;

import com.jgoodies.binding.beans.Model;
import com.rits.cloning.Cloner;
import com.rits.cloning.IFastCloner;

@SuppressWarnings("serial")
public final class PairSampleModel extends Model implements PairSample {

	private int pairNumber = DEFAULT_PAIR_NUMBER;
	private double learningRatio = DEFAULT_LEARNING_RATIO;

	@Override
	public void setPairNumber(int pairNumber) {
		firePropertyChange(PROPERTY_PAIR_NUMBER, this.pairNumber, this.pairNumber = pairNumber);
	}

	@Override
	public int getPairNumber() {
		return pairNumber;
	}

	@Override
	public void setLearningRatio(double learningRatio) {
		firePropertyChange(PROPERTY_LEARNING_RATIO, this.learningRatio, this.learningRatio = learningRatio);
	}

	@Override
	public double getLearningRatio() {
		return learningRatio;
	}

	public static class FastCloner implements IFastCloner {

		@Override
		public Object clone(Object t, Cloner cloner, Map<Object, Object> clones) throws IllegalAccessException {
			return new ModelCloner().deepClone(t);
		}
	}
}
