package fis.data.sample.pair;

import static com.jgoodies.validation.Severity.ERROR;
import static fis.LocaleFIS.GetString;
import static fis.data.sample.pair.PairSample.KEY_LEARNING_RATIO;
import static fis.data.sample.pair.PairSample.LABEL_LEARNING_RATIO;
import static util.jgoodies.validation.range.RangeUtils.percentValidator;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;

public class PairSampleValidator implements Validator<PairSample> {

	@Override
	public ValidationResult validate(PairSample pairSample) {
		return percentValidator(GetString(LABEL_LEARNING_RATIO), ERROR, KEY_LEARNING_RATIO, Double.class).validate(pairSample.getLearningRatio());
	}
}
