package fis.data.sample.seed;

import java.beans.PropertyChangeEvent;

import util.jgoodies.common.bean.BeanChangeListener;
import util.jgoodies.common.bean.ObservableBean2ChangeSupport;

public abstract class SeedChangeSupportDecorator extends SeedDecorator implements BeanChangeListener {

	private final ObservableBean2ChangeSupport changeSupport;

	public SeedChangeSupportDecorator(Seed seed) {
		super(seed);
		changeSupport = new ObservableBean2ChangeSupport(seed) {

			@Override
			public void beanChange(PropertyChangeEvent evt) {
				SeedChangeSupportDecorator.this.beanChange(evt);
			}
		};
	}

	public void release() {
		changeSupport.release();
	}
}
