package fis.optimization.crossvalidation;

import static com.jgoodies.validation.ValidationResult.EMPTY;
import static util.jgoodies.validation.ValidationUtils.validationResult;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;

import fis.data.sample.classif.ClassifSampleValidator;
import fis.data.sample.pair.PairSampleValidator;

public class CrossValidationValidator implements Validator<CrossValidation> {

	private final PairSampleValidator pairSampleValidator = new PairSampleValidator();
	private final ClassifSampleValidator classifSampleValidator = new ClassifSampleValidator();

	@Override
	public ValidationResult validate(CrossValidation crossValidation) {
		return crossValidation.isEnabled() ? validationResult(getPairSampleValidationResult(crossValidation), getClassifSampleValidationResult(crossValidation)) : EMPTY;
	}

	private ValidationResult getPairSampleValidationResult(CrossValidation crossValidation) {
		return pairSampleValidator.validate(crossValidation.getPairSample());
	}

	private ValidationResult getClassifSampleValidationResult(CrossValidation crossValidation) {
		return classifSampleValidator.validate(crossValidation.getClassifSample());
	}
}
