//***********************************************************************
//
//                              JPrintPreviewTable.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis.print;

import java.awt.Component;
import java.awt.print.Printable;
import java.awt.event.ActionListener;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import fis.*;

public class JPrintPreviewTable extends JPrintPreview {

  protected JTable table;

  public JPrintPreviewTable(Component parent, JTable table) { super(parent); this.table = table; }

  public void Show()
  {
  this.Init( new JPrintableTable(table) );
  }

  protected void ToolbarConstruct()
  {
  super.ToolbarConstruct();
  final JCheckBox fitToPage = new JCheckBox(LocaleFIS.GetString("FitToPage"));
  fitToPage.addItemListener(new java.awt.event.ItemListener() { public void itemStateChanged(ItemEvent e)
    {
    JPrintPreviewTable.this.fTarget = fitToPage.isSelected() == true ? (Printable)new JFitToPagePrintableTable(table) : new JPrintableTable(table);
    JPrintPreviewTable.this.ShowPreview();
    JPrintPreviewTable.this.pack();
    } });
  this.toolbar.add( fitToPage,    new GridBagConstraints(0, 1, 3, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 5, 5), 0, 0));
  }
}