package fis.swing.data.distance;

import static fis.LocaleFIS.GetString;
import static fis.data.distance.Distance.PROPERTY_NORMALIZE;
import static fis.data.distance.Distance.PROPERTY_OUTPUT_FILE;
import static java.awt.GridBagConstraints.BOTH;
import static java.awt.GridBagConstraints.CENTER;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

import util.swing.algorithm.distance.minkowski.JPanelMinkowski;
import util.swing.io.JPanelSaveAsFile;

import com.jgoodies.binding.adapter.Bindings;

@SuppressWarnings("serial")
public class JPanelDistance extends JPanel {

	private JPanelMinkowski panelMinkowski;
	private JPanelInputs panelInputs;
	private JCheckBox checkBoxNormalize;
	private JPanelSaveAsFile panelSaveAsFile;

	public JPanelDistance() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getPanelMinkowski(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, BOTH, new Insets(0, 0, 5, 0), 0, 0));
		add(getPanelInputs(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, BOTH, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(DistanceAdapter distanceAdapter) {
		getPanelMinkowski().bind(distanceAdapter.getMinkowskiAdapter());
		getPanelInputs().bind(distanceAdapter.getInputAdapters());
		add(getCheckBoxNormalize(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
		Bindings.bind(getCheckBoxNormalize(), distanceAdapter.getModel(PROPERTY_NORMALIZE));
		add(getPanelSaveAsFile(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
		getPanelSaveAsFile().bind(distanceAdapter.getModel(PROPERTY_OUTPUT_FILE), distanceAdapter.getOutputFileAction());
	}

	private JPanelMinkowski getPanelMinkowski() {
		if (panelMinkowski == null) {
			panelMinkowski = new JPanelMinkowski() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelDistance.this.add(comp, constraints);
				}
			};
		}
		return panelMinkowski;
	}

	private JPanelInputs getPanelInputs() {
		if (panelInputs == null) {
			panelInputs = new JPanelInputs() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelDistance.this.add(comp, constraints);
				}
			};
		}
		return panelInputs;
	}

	private JCheckBox getCheckBoxNormalize() {
		if (checkBoxNormalize == null) {
			checkBoxNormalize = new JCheckBox(GetString("Normalize"));
		}
		return checkBoxNormalize;
	}

	private JPanelSaveAsFile getPanelSaveAsFile() {
		if (panelSaveAsFile == null) {
			panelSaveAsFile = new JPanelSaveAsFile();
		}
		return panelSaveAsFile;
	}
}
