package fis.swing.data.distance.input;

import static com.jgoodies.binding.beans.PropertyConnector.connectAndUpdate;
import static fis.data.distance.input.Input.PROPERTY_DISTANCE;
import static fis.input.distance.Distances.AVAILABLE_DISTANCES;
import static fis.swing.data.distance.input.IsPreviewableConverter.isPreviewable;

import javax.swing.Action;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.list.SelectionInList;
import com.jgoodies.binding.value.ValueModel;

import fis.JInput;
import fis.data.distance.input.Input;
import fis.input.distance.Distance;
import fis.swing.data.distance.input.preview.PreviewAction;

@SuppressWarnings("serial")
public class InputAdapter extends PresentationModel<Input> {

	private final JInput jInput;
	private PreviewAction previewAction;

	public InputAdapter(Input input, JInput jInput, ValueModel normalizeModel) {
		super(input);
		this.jInput = jInput;
		connectAndUpdate(isPreviewable(getModel(PROPERTY_DISTANCE), normalizeModel), getPreviewAction(), "enabled");
	}

	public SelectionInList<Distance> getDistanceSelectionInList() {
		return new SelectionInList<Distance>(AVAILABLE_DISTANCES, getModel(PROPERTY_DISTANCE));
	}

	public Action getPreviewAction() {
		return previewAction != null ? previewAction : (previewAction = new PreviewAction(jInput));
	}
}
