package fis.swing.data.distance.input;

import static fis.data.distance.input.Input.PROPERTY_NAME;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.jgoodies.binding.adapter.Bindings;

@SuppressWarnings("serial")
public class JPanelInput extends JPanel {

	private JLabel labelName;
	private JComboBox comboBoxDistance;
	private JButton buttonPreview;

	public JPanelInput() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getLabelName(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getComboBoxDistance(), new GridBagConstraints(RELATIVE, RELATIVE, 1, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getButtonPreview(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(InputAdapter inputAdapter) {
		Bindings.bind(getLabelName(), inputAdapter.getModel(PROPERTY_NAME));
		Bindings.bind(getComboBoxDistance(), inputAdapter.getDistanceSelectionInList());
		getButtonPreview().setAction(inputAdapter.getPreviewAction());
	}

	private JLabel getLabelName() {
		if (labelName == null) {
			labelName = new JLabel();
		}
		return labelName;
	}

	private JComboBox getComboBoxDistance() {
		if (comboBoxDistance == null) {
			comboBoxDistance = new JComboBox();
			comboBoxDistance.setRenderer(new DistanceListCellRenderer());
		}
		return comboBoxDistance;
	}

	private JButton getButtonPreview() {
		if (buttonPreview == null) {
			buttonPreview = new JButton();
		}
		return buttonPreview;
	}
}
