package fis.swing.data.distance.input.preview;

import static java.awt.GridBagConstraints.CENTER;
import static java.awt.GridBagConstraints.NONE;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;

@SuppressWarnings("serial")
public class JPanelPreview extends JPanel {

	private ChartPanel chartPanel;

	public JPanelPreview() throws Throwable {
		initialize();
	}

	private void initialize() {
		setLayout(new GridBagLayout());
	}

	public void bind(PreviewAdapter previewAdapter) {
		add(getChartPanel(previewAdapter.getPreviewChart()), new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	private ChartPanel getChartPanel(JFreeChart previewChart) {
		if (chartPanel == null) {
			chartPanel = new ChartPanel(previewChart);
			chartPanel.setDomainZoomable(false);
			chartPanel.setRangeZoomable(false);
			chartPanel.setMinimumDrawWidth(200);
			chartPanel.setMinimumDrawHeight(200);
		}
		return chartPanel;
	}
}
