package fis.swing.data.distance.input.preview;

import static fis.LocaleFIS.GetString;
import static fis.util.JInputUtil.getInputName;
import static java.lang.String.format;
import static javax.swing.JOptionPane.DEFAULT_OPTION;
import static javax.swing.JOptionPane.PLAIN_MESSAGE;
import static javax.swing.JOptionPane.showOptionDialog;
import static util.swing.SwingUtilities.getWindowAncestor;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import util.swing.dialog.JOptionPaneException;
import fis.JInput;
import fis.data.distance.input.preview.DefaultPreview;

@SuppressWarnings("serial")
public class PreviewAction extends AbstractAction {

	private final JInput input;

	public PreviewAction(JInput input) {
		super(GetString("Preview"));
		this.input = input;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			JPanelPreview panelPreview = new JPanelPreview();
			panelPreview.bind(new PreviewAdapter(new DefaultPreview(input), input));
			showOptionDialog(getWindowAncestor(e.getSource()), panelPreview, format("%s: %s", getInputName(input), GetString("Difference")), DEFAULT_OPTION, PLAIN_MESSAGE, null, null, null);
		} catch (Throwable throwable) {
			JOptionPaneException.show(getWindowAncestor(e.getSource()), throwable);
		}
	}
}
