package fis.swing.data.distance.input.preview.jfree;

import static java.lang.Math.abs;
import static java.lang.Math.max;

import java.awt.Paint;

import fis.data.distance.input.preview.Preview;

@SuppressWarnings("serial")
public class PreviewAbsPaintScale extends PreviewPaintScale {

	public PreviewAbsPaintScale(Preview preview) {
		super(0, getMax(preview));
	}

	private static double getMax(Preview preview) {
		return getMax(preview.getDistanceMin(), preview.getDistanceMax());
	}

	private static double getMax(double min, double max) {
		return isEmptyRange(min, max) ? 1 : max(abs(min), abs(max));
	}

	@Override
	public Paint getPaint(double value) {
		return super.getPaint(abs(value));
	}
}
