package fis.swing.data.distance.input.preview.jfree;

import static fis.data.distance.input.preview.Preview.DISTANCE_COUNT;
import static fis.util.JInputUtil.getInputRange;

import java.awt.image.Raster;

import util.jfree.data.xy.RasterDataset;
import fis.JInput;

public class PreviewDataset extends RasterDataset {

	private final JInput input;

	public PreviewDataset(Raster raster, JInput input) {
		super(raster);
		this.input = input;
	}

	@Override
	public double getXValue(int series, int item) {
		return unNormalizeInput(super.getXValue(series, item) / (DISTANCE_COUNT - 1), getInputRange(input));
	}

	private double unNormalizeInput(double value, double[] range) {
		return range[0] + value * (range[1] - range[0]);
	}

	@Override
	public double getYValue(int series, int item) {
		return unNormalizeInput(super.getYValue(series, item) / (DISTANCE_COUNT - 1), getInputRange(input));
	}
}
