package fis.swing.data.distance.input.preview.jfree;

import java.awt.Color;
import java.awt.Paint;

import org.jfree.chart.renderer.GrayPaintScale;

import fis.data.distance.input.preview.Preview;

@SuppressWarnings("serial")
public class PreviewPaintScale extends GrayPaintScale {

	public PreviewPaintScale(Preview preview) {
		this(getMin(preview), getMax(preview));
	}

	public PreviewPaintScale(double min, double max) {
		super(min, max);
	}

	private static double getMin(Preview preview) {
		return getMin(preview.getDistanceMin(), preview.getDistanceMax());
	}

	private static double getMax(Preview preview) {
		return getMax(preview.getDistanceMin(), preview.getDistanceMax());
	}

	private static double getMin(double min, double max) {
		return isEmptyRange(min, max) ? 0 : min;
	}

	private static double getMax(double min, double max) {
		return isEmptyRange(min, max) ? 1 : max;
	}

	protected static boolean isEmptyRange(double min, double max) {
		return (max - min) < 1e-10;
	}

	@Override
	public Paint getPaint(double value) {
		return reverseColor((Color) super.getPaint(value));
	}

	private static Color reverseColor(Color color) {
		return new Color(255 - color.getRed(), 255 - color.getGreen(), 255 - color.getBlue());
	}
}
