package fis.swing.data.distance.input.preview.jfree;

import static fis.LocaleFIS.GetString;
import static fis.data.distance.input.preview.Preview.DISTANCE_COUNT;
import static fis.util.JInputUtil.getInputRange;
import static java.lang.String.format;

import org.jfree.chart.labels.StandardXYZToolTipGenerator;
import org.jfree.chart.renderer.xy.XYBlockRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYZDataset;

import fis.JInput;
import fis.data.distance.input.preview.Preview;

@SuppressWarnings("serial")
public class PreviewRenderer extends XYBlockRenderer {

	public PreviewRenderer(Preview preview, JInput input) {
		setPaintScale(new PreviewColorPaintScale(preview));
		setBlockWidth(unNormalizeBlockSize(getInputRange(input)));
		setBlockHeight(unNormalizeBlockSize(getInputRange(input)));
		setBaseToolTipGenerator(new StandardXYZToolTipGenerator() {

			@Override
			public String generateLabelString(XYDataset dataset, int series, int item) {
				Object[] items = createItemArray((XYZDataset) dataset, series, item);
				return format("%s(%s, %s) = %s", GetString("Difference").toLowerCase(), items[1], items[2], removeNegativeZero(items[3]));
			}

			private Object removeNegativeZero(Object value) {
				return format("%s", value).replaceAll("^-(?=0(.0*)?$)", "");
			}
		});
	}

	private double unNormalizeBlockSize(double[] range) {
		return (range[1] - range[0]) / (DISTANCE_COUNT - 1);
	}
}
