package fis.swing.data.sample.block;

import static com.jgoodies.binding.adapter.SpinnerAdapterFactory.createNumberAdapter;
import static fis.LocaleFIS.GetString;
import static fis.data.sample.block.BlockSample.DEFAULT_BLOCK_NUMBER;
import static fis.data.sample.block.BlockSample.MAX_BLOCK_NUMBER;
import static fis.data.sample.block.BlockSample.MIN_BLOCK_NUMBER;
import static fis.data.sample.block.BlockSample.PROPERTY_CONSTANT_SIZE;
import static fis.data.sample.block.BlockSample.PROPERTY_NUMBER;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;
import static javax.swing.Box.createGlue;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;

import com.jgoodies.binding.adapter.Bindings;

@SuppressWarnings("serial")
public class JPanelBlockSample extends JPanel {

	private JLabel labelNumber;
	private JSpinner spinnerNumber;
	private JCheckBox checkBoxConstantSize;

	public JPanelBlockSample() {
		initialize();
	}

	private void initialize() {
		setLayout(new GridBagLayout());
		add(getLabelNumber(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 5, 5), 0, 0));
		add(getSpinnerNumber(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getCheckBoxConstantSize(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(createGlue(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 5, 0), 0, 0));
	}

	public void bind(BlockSampleAdapter blockSampleAdapter) {
		getSpinnerNumber().setModel(createNumberAdapter(blockSampleAdapter.getBufferedModel(PROPERTY_NUMBER), DEFAULT_BLOCK_NUMBER, MIN_BLOCK_NUMBER, MAX_BLOCK_NUMBER, 1));
		Bindings.bind(getCheckBoxConstantSize(), blockSampleAdapter.getBufferedModel(PROPERTY_CONSTANT_SIZE));
	}

	private JLabel getLabelNumber() {
		if (labelNumber == null) {
			labelNumber = new JLabel(GetString("SampleNumber"));
		}
		return labelNumber;
	}

	private JSpinner getSpinnerNumber() {
		if (spinnerNumber == null) {
			spinnerNumber = new JSpinner();
		}
		return spinnerNumber;
	}

	private JCheckBox getCheckBoxConstantSize() {
		if (checkBoxConstantSize == null) {
			checkBoxConstantSize = new JCheckBox(GetString("Truncate"));
		}
		return checkBoxConstantSize;
	}
}
