package fis.swing.data.sample.classif;

import static com.humaorie.dollar.Dollar.$;
import static fis.data.sample.classif.ClassifSample.PROPERTY_CLASSIF_VARIABLE;

import javax.swing.ListCellRenderer;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.list.SelectionInList;
import com.jgoodies.binding.value.ValueModel;

import fis.JExtendedDataFile;
import fis.JFIS;
import fis.data.sample.classif.ClassifSample;

@SuppressWarnings("serial")
public class ClassifSampleAdapter extends PresentationModel<ClassifSample> {

	private final JExtendedDataFile data;
	private final JFIS fis;

	public ClassifSampleAdapter(ClassifSample classifSample, ValueModel triggerChannel, JExtendedDataFile data, JFIS fis) {
		super(classifSample, triggerChannel);
		this.data = data;
		this.fis = fis;
	}

	public SelectionInList<Integer> getVariableSelectionInList() {
		return new SelectionInList<Integer>(getVariables(), getBufferedModel(PROPERTY_CLASSIF_VARIABLE), new VariableSelectionIndex(fis));
	}

	private Integer[] getVariables() {
		return $(data.VariableCount()).toArray();
	}

	public ListCellRenderer getVariableListCellRenderer() {
		return new VariableListCellRenderer(data, fis);
	}
}
