package fis.swing.data.sample.classif;

import static com.jgoodies.validation.view.ValidationComponentUtils.setMessageKey;
import static fis.LocaleFIS.GetString;
import static fis.data.sample.classif.ClassifSample.KEY_PRECISION;
import static fis.data.sample.classif.ClassifSample.LABEL_PRECISION;
import static fis.data.sample.classif.ClassifSample.PROPERTY_CLASSIF;
import static fis.data.sample.classif.ClassifSample.PROPERTY_PRECISION;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import util.jgoodies.binding.value.FlowConverter;
import util.swing.JFormattedTextFieldDouble;

import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.beans.PropertyConnector;
import com.jgoodies.binding.value.AbstractValueModel;


@SuppressWarnings("serial")
public class JPanelClassifSample extends JPanel {

	private JCheckBox checkBoxClassif;
	private JComboBox comboBoxVariable;
	private JLabel labelPrecision;
	private JFormattedTextFieldDouble fieldPrecision;

	public JPanelClassifSample() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getCheckBoxClassif(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 5, 5), 0, 0));
		add(getComboBoxVariable(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getLabelPrecision(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getFieldPrecision(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(ClassifSampleAdapter classifSampleAdapter) {
		bind(classifSampleAdapter.getBufferedModel(PROPERTY_CLASSIF));
		Bindings.bind(getFieldPrecision(), classifSampleAdapter.getBufferedModel(PROPERTY_PRECISION));
		Bindings.bind(getComboBoxVariable(), classifSampleAdapter.getVariableSelectionInList());
		getComboBoxVariable().setRenderer(classifSampleAdapter.getVariableListCellRenderer());
	}

	private void bind(AbstractValueModel classif) {
		Bindings.bind(getCheckBoxClassif(), classif);
		bind(new FlowConverter(classif));
	}

	private void bind(FlowConverter flowClassif) {
		PropertyConnector.connectAndUpdate(flowClassif, getLabelPrecision(), "enabled");
		PropertyConnector.connectAndUpdate(flowClassif, getFieldPrecision(), "enabled");
		PropertyConnector.connectAndUpdate(flowClassif, getComboBoxVariable(), "enabled");
	}

	private JCheckBox getCheckBoxClassif() {
		if (checkBoxClassif == null) {
			checkBoxClassif = new JCheckBox(GetString("ClassSample"));
		}
		return checkBoxClassif;
	}

	private JComboBox getComboBoxVariable() {
		if (comboBoxVariable == null) {
			comboBoxVariable = new JComboBox();
		}
		return comboBoxVariable;
	}

	private JLabel getLabelPrecision() {
		if (labelPrecision == null) {
			labelPrecision = new JLabel(GetString(LABEL_PRECISION));
		}
		return labelPrecision;
	}

	private JFormattedTextFieldDouble getFieldPrecision() {
		if (fieldPrecision == null) {
			fieldPrecision = new JFormattedTextFieldDouble();
			fieldPrecision.setColumns(5);
			setMessageKey(fieldPrecision, KEY_PRECISION);
		}
		return fieldPrecision;
	}
}
