package fis.swing.data.sample.classif;

import static fis.LocaleFIS.GetString;
import static fis.util.JFISUtil.getFISInputName;

import java.awt.Component;

import javax.swing.JList;

import util.swing.EnableableListCellRenderer;
import fis.JExtendedDataFile;
import fis.JFIS;

@SuppressWarnings("serial")
public class VariableListCellRenderer extends EnableableListCellRenderer {

	private final JExtendedDataFile data;
	private final JFIS fis;

	public VariableListCellRenderer(JExtendedDataFile data, JFIS fis) {
		super(new VariablePredicate(fis));
		this.data = data;
		this.fis = fis;
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		return super.getListCellRendererComponent(list, getVariableName(value), index, isSelected, cellHasFocus);
	}

	private String getVariableName(Object value) {
		return value != null ? getVariableName((Integer) value) : null;
	}

	private String getVariableName(Integer variableIndex) {
		return fis != null ? getFisVariableName(variableIndex) : getDataVariableName(data.getVariableName(), variableIndex);
	}

	private String getFisVariableName(Integer variableIndex) {
		return getFISInputName(fis, variableIndex);
	}

	private String getDataVariableName(String[] variableNames, Integer variableIndex) {
		return variableNames != null ? variableNames[variableIndex] : getDefaultVariableName(variableIndex);
	}

	private String getDefaultVariableName(Integer variableIndex) {
		return String.format("%s %d", GetString("Variable"), variableIndex);
	}
}
