package fis.swing.data.sample.generator.block;

import static java.awt.GridBagConstraints.CENTER;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;

import fis.swing.data.sample.block.JPanelBlockSample;
import fis.swing.data.sample.classif.JPanelClassifSample;
import fis.swing.data.sample.seed.JPanelSeed;

@SuppressWarnings("serial")
public class JPanelBlockSampleGenerator extends JPanel {

	private JPanelBlockSample panelBlockSample;
	private JPanelClassifSample panelClassifSample;
	private JPanelSeed panelSeed;

	public JPanelBlockSampleGenerator() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getPanelBlockSample(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getPanelClassifSample(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getPanelSeed(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}


	public void bind(BlockSampleGeneratorAdapter blockSampleGeneratorAdapter) {
		getPanelBlockSample().bind(blockSampleGeneratorAdapter.getBlockSampleAdapter());
		getPanelClassifSample().bind(blockSampleGeneratorAdapter.getClassifSampleAdapter());
		getPanelSeed().bind(blockSampleGeneratorAdapter.getSeedAdapter());		
	}

	private JPanelBlockSample getPanelBlockSample() {
		if (panelBlockSample == null) {
			panelBlockSample = new JPanelBlockSample() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelBlockSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelBlockSample;
	}

	private JPanelClassifSample getPanelClassifSample() {
		if (panelClassifSample == null) {
			panelClassifSample = new JPanelClassifSample() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelBlockSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelClassifSample;
	}

	private JPanelSeed getPanelSeed() {
		if (panelSeed == null) {
			panelSeed = new JPanelSeed() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelBlockSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelSeed;
	}
}
