package fis.swing.data.sample.generator.pair;

import static java.awt.GridBagConstraints.CENTER;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;

import fis.swing.data.sample.classif.JPanelClassifSample;
import fis.swing.data.sample.pair.JPanelPairSample;
import fis.swing.data.sample.seed.JPanelSeed;

@SuppressWarnings("serial")
public class JPanelPairSampleGenerator extends JPanel {

	private JPanelPairSample panelPairSample;
	private JPanelClassifSample panelClassifSample;
	private JPanelSeed panelSeed;

	public JPanelPairSampleGenerator() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getPanelPairSample(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getPanelClassifSample(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 5, 0), 0, 0));
		add(getPanelSeed(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(PairSampleGeneratorAdapter pairSampleGeneratorAdapter) {
		getPanelPairSample().bind(pairSampleGeneratorAdapter.getPairSampleAdapter());
		getPanelClassifSample().bind(pairSampleGeneratorAdapter.getClassifSampleAdapter());
		getPanelSeed().bind(pairSampleGeneratorAdapter.getSeedAdapter());
	}
	
	private JPanelPairSample getPanelPairSample() {
		if (panelPairSample == null) {
			panelPairSample = new JPanelPairSample() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelPairSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelPairSample;
	}

	private JPanelClassifSample getPanelClassifSample() {
		if (panelClassifSample == null) {
			panelClassifSample = new JPanelClassifSample() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelPairSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelClassifSample;
	}

	private JPanelSeed getPanelSeed() {
		if (panelSeed == null) {
			panelSeed = new JPanelSeed() {

				@Override
				public void add(Component comp, Object constraints) {
					JPanelPairSampleGenerator.this.add(comp, constraints);
				}
			};
		}
		return panelSeed;
	}
}
