package fis.swing.data.sample.pair;

import static com.jgoodies.binding.adapter.SpinnerAdapterFactory.createNumberAdapter;
import static com.jgoodies.binding.value.ConverterFactory.createDoubleConverter;
import static com.jgoodies.validation.view.ValidationComponentUtils.setMessageKey;
import static fis.LocaleFIS.GetString;
import static fis.data.sample.pair.PairSample.DEFAULT_PAIR_NUMBER;
import static fis.data.sample.pair.PairSample.KEY_LEARNING_RATIO;
import static fis.data.sample.pair.PairSample.LABEL_LEARNING_RATIO;
import static fis.data.sample.pair.PairSample.MAX_PAIR_NUMBER;
import static fis.data.sample.pair.PairSample.MIN_PAIR_NUMBER;
import static fis.data.sample.pair.PairSample.PROPERTY_LEARNING_RATIO;
import static fis.data.sample.pair.PairSample.PROPERTY_PAIR_NUMBER;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;

import util.swing.JFormattedTextFieldDouble;

import com.jgoodies.binding.adapter.Bindings;


@SuppressWarnings("serial")
public class JPanelPairSample extends JPanel {

	private JLabel labelPairNumber;
	private JLabel labelLearningRatio;
	private JFormattedTextFieldDouble fieldLearningRatio;
	private JSpinner spinnerPairNumber;
	private JLabel labelPercent;

	public JPanelPairSample() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getLabelPairNumber(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 5, 5), 0, 0));
		add(getSpinnerPairNumber(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 5, 5), 0, 0));
		add(getLabelLearningRatio(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getFieldLearningRatio(), new GridBagConstraints(RELATIVE, RELATIVE, 1, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getLabelPercent(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(PairSampleAdapter pairSampleAdapter) {
		getSpinnerPairNumber().setModel(createNumberAdapter(pairSampleAdapter.getBufferedModel(PROPERTY_PAIR_NUMBER), DEFAULT_PAIR_NUMBER, MIN_PAIR_NUMBER, MAX_PAIR_NUMBER, 1));
		Bindings.bind(getFieldLearningRatio(), createDoubleConverter(pairSampleAdapter.getBufferedModel(PROPERTY_LEARNING_RATIO), 100d));
	}

	private JLabel getLabelPairNumber() {
		if (labelPairNumber == null) {
			labelPairNumber = new JLabel(GetString("PairSampleNumber"));
		}
		return labelPairNumber;
	}

	private JLabel getLabelLearningRatio() {
		if (labelLearningRatio == null) {
			labelLearningRatio = new JLabel(GetString(LABEL_LEARNING_RATIO));
		}
		return labelLearningRatio;
	}

	private JFormattedTextFieldDouble getFieldLearningRatio() {
		if (fieldLearningRatio == null) {
			fieldLearningRatio = new JFormattedTextFieldDouble();
			fieldLearningRatio.setColumns(5);
			setMessageKey(fieldLearningRatio, KEY_LEARNING_RATIO);
		}
		return fieldLearningRatio;
	}

	private JSpinner getSpinnerPairNumber() {
		if (spinnerPairNumber == null) {
			spinnerPairNumber = new JSpinner();
		}
		return spinnerPairNumber;
	}

	private JLabel getLabelPercent() {
		if (labelPercent == null) {
			labelPercent = new JLabel("%");
		}
		return labelPercent;
	}
}
