package fis.swing.data.sample.seed;

import static fis.LocaleFIS.GetString;
import static fis.data.sample.seed.Seed.PROPERTY_SEED;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;

import util.swing.JFormattedTextFieldInteger;

import com.jgoodies.binding.adapter.Bindings;


@SuppressWarnings("serial")
public class JPanelSeed extends JPanel {

	private JLabel labelSeed;
	private JFormattedTextFieldInteger fieldSeed;

	public JPanelSeed() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getLabelSeed(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getFieldSeed(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(SeedAdapter seedAdapter) {
		Bindings.bind(getFieldSeed(), seedAdapter.getBufferedModel(PROPERTY_SEED));
	}

	private JLabel getLabelSeed() {
		if (labelSeed == null) {
			labelSeed = new JLabel(GetString("Seed"));
		}
		return labelSeed;
	}

	private JFormattedTextFieldInteger getFieldSeed() {
		if (fieldSeed == null) {
			fieldSeed = new JFormattedTextFieldInteger();
			fieldSeed.setColumns(5);
		}
		return fieldSeed;
	}
}
