package fis.swing.optimization.crossvalidation;

import static com.jgoodies.binding.beans.PropertyConnector.connectAndUpdate;
import static fis.optimization.crossvalidation.CrossValidation.PROPERTY_ENABLED;

import javax.swing.Action;

import com.jgoodies.binding.PresentationModel;

import fis.JExtendedDataFile;
import fis.JFIS;
import fis.optimization.crossvalidation.CrossValidation;
import fis.swing.optimization.crossvalidation.parameters.CrossValidationParametersAction;

@SuppressWarnings("serial")
public class CrossValidationAdapter extends PresentationModel<CrossValidation> {

	private final JExtendedDataFile data;
	private final JFIS fis;
	private Action parametersAction;

	public CrossValidationAdapter(CrossValidation crossValidation, JExtendedDataFile data, JFIS fis) {
		super(crossValidation);
		this.data = data;
		this.fis = fis;
		connectAndUpdate(getModel(PROPERTY_ENABLED), getParametersAction(), "enabled");
	}

	public Action getParametersAction() {
		return parametersAction != null ? parametersAction : (parametersAction = new CrossValidationParametersAction(getBean(), data, fis));
	}
}
