package fis.swing.optimization.crossvalidation;

import static fis.LocaleFIS.GetString;
import static fis.optimization.crossvalidation.CrossValidation.LABEL_CROSS_VALIDATION;
import static fis.optimization.crossvalidation.CrossValidation.PROPERTY_ENABLED;
import static java.awt.GridBagConstraints.CENTER;
import static java.awt.GridBagConstraints.NONE;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import com.jgoodies.binding.adapter.Bindings;


@SuppressWarnings("serial")
public class JPanelCrossValidation extends JPanel {

	private JCheckBox checkBoxEnabled;
	private JButton buttonParameters;

	public JPanelCrossValidation() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getCheckBoxEnabled(), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getButtonParameters(), new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(CrossValidationAdapter crossValidationAdapter) {
		Bindings.bind(getCheckBoxEnabled(), crossValidationAdapter.getModel(PROPERTY_ENABLED));
		getButtonParameters().setAction(crossValidationAdapter.getParametersAction());
	}

	private JCheckBox getCheckBoxEnabled() {
		if (checkBoxEnabled == null) {
			checkBoxEnabled = new JCheckBox(GetString(LABEL_CROSS_VALIDATION));
		}
		return checkBoxEnabled;
	}

	private JButton getButtonParameters() {
		if (buttonParameters == null) {
			buttonParameters = new JButton();
		}
		return buttonParameters;
	}
}
