package fis.swing.optimization.crossvalidation.parameters;

import static fis.LocaleFIS.GetString;
import static fis.optimization.crossvalidation.CrossValidation.LABEL_CROSS_VALIDATION;
import static javax.swing.JOptionPane.OK_CANCEL_OPTION;
import static javax.swing.JOptionPane.PLAIN_MESSAGE;
import static javax.swing.JOptionPane.showOptionDialog;
import static util.swing.SwingUtilities.getWindowAncestor;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import util.jgoodies.validation.ValidationResultAdapter;
import fis.JExtendedDataFile;
import fis.JFIS;
import fis.LocaleFIS;
import fis.optimization.crossvalidation.CrossValidation;

@SuppressWarnings("serial")
public class CrossValidationParametersAction extends AbstractAction {

	private final CrossValidation crossValidation;
	private final JExtendedDataFile data;
	private final JFIS fis;

	public CrossValidationParametersAction(CrossValidation crossValidation, JExtendedDataFile data, JFIS fis) {
		super(LocaleFIS.GetString("Parameters"));
		this.crossValidation = crossValidation;
		this.data = data;
		this.fis = fis;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		CrossValidationParameterAdapter crossValidationParameterAdapter = new CrossValidationParameterAdapter(crossValidation, data, fis);
		JPanelCrossValidationParameters panelCrossValidationParameters = new JPanelCrossValidationParameters();
		panelCrossValidationParameters.bind(crossValidationParameterAdapter);
		ValidationResultAdapter validationResultAdapter = new ValidationResultAdapter(panelCrossValidationParameters, crossValidationParameterAdapter);
		showOptionDialog(getWindowAncestor(e.getSource()), panelCrossValidationParameters, GetString(LABEL_CROSS_VALIDATION), OK_CANCEL_OPTION, PLAIN_MESSAGE, null, crossValidationParameterAdapter.getOptions(), crossValidationParameterAdapter.getInitialOption());
		validationResultAdapter.release();
		crossValidationParameterAdapter.release();
	}
}
