//***********************************************************************
//
//                              ExtendedYAxisBuilder.java
//
// Author(s) : Mathieu GRELIER
// FISPRO Version : 3.0 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Contact : fispro@ensam.inra.fr
// Last modification date:  December 25, 2005
//
//**********************************************************************
package org.freehep.j3d.plot;

import javax.media.j3d.*;
import javax.vecmath.*;

public class ExtendedYAxisBuilder extends ExtendedAxisBuilder {
    public ExtendedYAxisBuilder() {}

    public ExtendedYAxisBuilder(String label, String[] tickLabels, double[] tickLocations) {
        setLabel(label);
        setTickLabels(tickLabels);
        setTickLocations(tickLocations);
    }

    public Node getNode() {
        Transform3D t3d = new Transform3D();
        t3d.set(1 / scale, new Vector3f(-0.5f, +0.5f, 0));
        Transform3D rot = new Transform3D();
        rot.rotZ(-Math.PI / 2);
        t3d.mul(rot);
        TransformGroup tg = new TransformGroup(t3d);
        tg.addChild(super.getNode());
        return tg;

    }
}
