//***********************************************************************
//
//                              PickAndClickProcessable.java
//
// Author(s) : Mathieu GRELIER
// FISPRO Version : 3.0 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Contact : fispro@ensam.inra.fr
// Last modification date:  December 25, 2005
//
//**********************************************************************
package org.freehep.j3d.plot;

import com.sun.j3d.utils.picking.PickResult;

/**
 * Description : an interface defining the differents methods that must be implemented
 * for a class to use the PickAndClickBehavior
 */
public interface PickAndClickProcessable {

    void setPickCapability(); //when defining this method, use PickTool.setCapabilities to set the correct capabilities in your scene graph

    //In Fispro : it is called once the graph is constructed, in the Plot3D's init() method, called itself only one time, when the the 3D rendering of this graph is shown for the first time on the screen
    //the Plot3D createPlot method is called in init() also, just before
    void setMousePosition(int x, int y); //to record the mouse pos. (in two fields for example) to use it in the following methods

    void processIntersection(PickResult result);

    void processNoIntersection();

    void processLeftClick(PickResult result);

    void processRightClick(PickResult result);

    void processCenterClick(PickResult result);

    void processLeftDoubleClick(PickResult result);

}