package util.algorithm.distance.minkowski;

import java.beans.PropertyChangeEvent;

import util.jgoodies.common.bean.BeanChangeListener;
import util.jgoodies.common.bean.ObservableBean2ChangeSupport;

public abstract class MinkowskiChangeSupportDecorator extends MinkowskiDecorator implements BeanChangeListener {

	private final ObservableBean2ChangeSupport changeSupport;

	public MinkowskiChangeSupportDecorator(Minkowski minkowski) {
		super(minkowski);
		changeSupport = new ObservableBean2ChangeSupport(minkowski) {

			@Override
			public void beanChange(PropertyChangeEvent evt) {
				MinkowskiChangeSupportDecorator.this.beanChange(evt);
			}
		};
	}

	public void release() {
		changeSupport.release();
	}
}
