package util.algorithm.distance.minkowski;

import static com.jgoodies.validation.Severity.ERROR;
import static util.LocaleUtil.GetString;
import static util.algorithm.distance.minkowski.Minkowski.KEY_POWER;
import static util.algorithm.distance.minkowski.Minkowski.LABEL_POWER;
import static util.jgoodies.validation.range.RangeUtils.atLeastValidator;

import com.jgoodies.validation.ValidationResult;
import com.jgoodies.validation.Validator;

public class MinkowskiValidator implements Validator<Minkowski> {

	private final Validator<Double> validator = atLeastValidator(GetString(LABEL_POWER), ERROR, KEY_POWER, 1d);

	@Override
	public ValidationResult validate(Minkowski minkowski) {
		return validator.validate(minkowski.getPower());
	}
}
