package util.jgoodies.binding.list;

import com.google.common.base.Predicate;
import com.jgoodies.binding.value.AbstractValueModel;

@SuppressWarnings("serial")
public class PredicateSelectionIndex extends AbstractValueModel {

    private static final int NO_SELECTION_INDEX = -1;

    private int index = NO_SELECTION_INDEX;
	private final Predicate<Integer> predicate;

	public PredicateSelectionIndex(Predicate<Integer> predicate) {
		this.predicate = predicate;
	}

	@Override
	public Object getValue() {
		return index;
	}

	@Override
	public void setValue(Object newValue) {
		if(predicate.apply((Integer) newValue))
			fireValueChange(index, index = (Integer) newValue);
	}
}
