package util.jgoodies.binding.value;

import java.io.File;

import com.jgoodies.binding.value.AbstractConverter;
import com.jgoodies.binding.value.ValueModel;

public class FileConverterUtils {

	public static FileToNameConverter toNameConverter(ValueModel subject) {
		return new FileToNameConverter(subject);
	}

	public static FileToPathConverter toPathConverter(ValueModel subject) {
		return new FileToPathConverter(subject);
	}

	@SuppressWarnings("serial")
	private static abstract class FileConverter extends AbstractConverter {

		public FileConverter(ValueModel subject) {
			super(subject);
		}

		@Override
		public void setValue(Object newValue) {
			subject.setValue(newValue != null ? new File((String) newValue) : null);
		}

		@Override
		public Object convertFromSubject(Object subjectValue) {
			return convertFromFile((File) subjectValue);
		}

		protected abstract Object convertFromFile(File file);
	}

	@SuppressWarnings("serial")
	private static class FileToNameConverter extends FileConverter {

		public FileToNameConverter(ValueModel subject) {
			super(subject);
		}

		@Override
		protected Object convertFromFile(File file) {
			return file != null ? file.getName() : null;
		}
	}

	@SuppressWarnings("serial")
	private static class FileToPathConverter extends FileConverter {

		public FileToPathConverter(ValueModel subject) {
			super(subject);
		}

		@Override
		protected Object convertFromFile(File file) {
			return file != null ? file.getPath() : null;
		}
	}
}
