package util.jgoodies.binding.value;

import javax.swing.Action;

import util.swing.ActionDecorator;
import util.swing.dialog.JOptionPaneAction;

import com.jgoodies.binding.value.Trigger;
import com.jgoodies.binding.value.ValueModel;

@SuppressWarnings("serial")
public abstract class TriggerableAction extends ActionDecorator {

	public static int COMMITABLE = 0;
	public static int FLUSHABLE = 1;

	private final Trigger trigger;

	public TriggerableAction(Trigger trigger, Action action) {
		super(action);
		this.trigger = trigger;
	}

	protected Trigger getTrigger() {
		return trigger;
	}

	public static Action[] createCommitFlushActions(ValueModel triggerChannel) {
		return createCommitFlushActions((Trigger) triggerChannel);
	}

	public static Action[] createCommitFlushActions(ValueModel triggerChannel, Action[] actions) {
		return createCommitFlushActions((Trigger) triggerChannel, actions);
	}

	public static Action[] createCommitFlushActions(Trigger trigger) {
		return createCommitFlushActions(trigger, JOptionPaneAction.createOkCancelActions());
	}

	public static Action[] createCommitFlushActions(Trigger trigger, Action[] actions) {
		assert actions.length == 2;
		return new Action[] { new CommitableAction(trigger, actions[COMMITABLE]), new FlushableAction(trigger, actions[FLUSHABLE]) };
	}
}
