package util.jgoodies.common.bean;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import com.jgoodies.common.bean.ObservableBean2;

public abstract class ObservableBean2ChangeSupport implements BeanChangeListener {

	private final ChangeListener changeListener = new ChangeListener();
	private final ObservableBean2 observable;

	public ObservableBean2ChangeSupport(ObservableBean2 observable) {
		this.observable = observable;
		addChangeListener();
	}

	private void addChangeListener() {
		observable.addPropertyChangeListener(changeListener);
	}

	public void release() {
		removeChangeListener();
	}

	private void removeChangeListener() {
		observable.removePropertyChangeListener(changeListener);
	}

	private class ChangeListener implements PropertyChangeListener {

		@Override
		public void propertyChange(PropertyChangeEvent evt) {
			ObservableBean2ChangeSupport.this.beanChange(evt);
		}
	}
}