package util.jgoodies.common.bean;

import java.beans.PropertyChangeListener;

import com.jgoodies.common.bean.ObservableBean2;

public class ObservableBean2Decorator<T extends ObservableBean2> implements ObservableBean2 {

	private final T bean;

	public ObservableBean2Decorator(T bean) {
		this.bean = bean;
	}

	public T getBean() {
		return bean;
	}

	@Override
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		getBean().addPropertyChangeListener(listener);
	}

	@Override
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		getBean().removePropertyChangeListener(listener);
	}

	@Override
	public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
		getBean().addPropertyChangeListener(propertyName, listener);
	}

	@Override
	public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
		getBean().removePropertyChangeListener(propertyName, listener);
	}

	@Override
	public PropertyChangeListener[] getPropertyChangeListeners() {
		return getBean().getPropertyChangeListeners();
	}

	@Override
	public PropertyChangeListener[] getPropertyChangeListeners(String propertyName) {
		return getBean().getPropertyChangeListeners(propertyName);
	}
}
