package util.jgoodies.validation;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import util.swing.ActionDecorator;
import util.swing.SwingUtilities;
import util.swing.dialog.JOptionPaneAction;
import util.swing.dialog.validation.JOptionPaneValidationResult;

import com.jgoodies.validation.ValidationResultModel;

@SuppressWarnings("serial")
public class ValidatableAction extends ActionDecorator {

	private final ValidationResultModel validationResultModel;

	public ValidatableAction(ValidationResultModel validationResultModel, Action action) {
		super(action);
		this.validationResultModel = validationResultModel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if(!validationResultModel.getResult().isEmpty())
			JOptionPaneValidationResult.show(SwingUtilities.getWindowAncestor(e.getSource()), validationResultModel.getResult());
		if(!validationResultModel.getResult().hasErrors())
			super.actionPerformed(e);
	}

	public static Action[] createOkValidatableCancelActions(ValidationResultModel validationResultModel, Action[] actions) {
		assert actions.length == 2;
		return new Action[] { new ValidatableAction(validationResultModel, actions[0]), actions[1] };
	}

	public static Action[] createOkValidatableCancelActions(ValidationResultModel validationResultModel) {
		return createOkValidatableCancelActions(validationResultModel, JOptionPaneAction.createOkCancelActions());
	}
}
