package util.jgoodies.validation.range;

import com.google.common.collect.Range;
import com.jgoodies.validation.Severity;
import com.jgoodies.validation.message.AbstractValidationMessage;

@SuppressWarnings("serial")
public final class RangeValidationMessage extends AbstractValidationMessage {

	public RangeValidationMessage(String name, Range<?> range, Severity severity) {
		super(getText(name, range), severity);
	}

	public RangeValidationMessage(String name, Range<?> range, Severity severity, Object key) {
		super(getText(name, range), severity, key);
	}

	private static String getText(String name, Range<?> range) {
		return String.format("'%s' in range %s", name, range);
	}
}
