package util.swing;

import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.AbstractAction;
import javax.swing.Action;

@SuppressWarnings("serial")
public class ActionDecorator extends AbstractAction {

	private final Action action;

	public ActionDecorator(Action action) {
		this.action = action;
		putValue(Action.NAME, action.getValue(Action.NAME));
		putValue(Action.SMALL_ICON, action.getValue(Action.SMALL_ICON));
		addActionChangeListener();
	}

	private void addActionChangeListener() {
		this.action.addPropertyChangeListener(new PropertyChangeListener() {

			@Override
			public void propertyChange(PropertyChangeEvent evt) {
				propertyChange(evt.getPropertyName(), evt.getNewValue());
			}

			private void propertyChange(String propertyName, Object newValue) {
				if((propertyName != null) && propertyName.equals("enabled"))
					setEnabled((Boolean) newValue);
			}
		});
		setEnabled(action.isEnabled());
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		action.actionPerformed(e);
	}
}
