package util.swing;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

import com.google.common.base.Predicate;

@SuppressWarnings("serial")
public class EnableableListCellRenderer extends DefaultListCellRenderer {

	private final Predicate<Integer> enableablePredicate;

	public EnableableListCellRenderer(Predicate<Integer> enableablePredicate) {
		this.enableablePredicate = enableablePredicate;
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		Component component = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
		component.setEnabled(enableablePredicate.apply(index));
		return component;
	}
}
