package util.swing.action.performable;

import static util.swing.SwingUtilities.getWindowAncestor;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import util.swing.ActionDecorator;
import util.swing.dialog.JOptionPaneException;

@SuppressWarnings("serial")
public class PerformableActionDecorator extends ActionDecorator {

	private final PerformableActionListener performableActionListener;

	public PerformableActionDecorator(Action action, PerformableActionListener performableActionListener) {
		super(action);
		this.performableActionListener = performableActionListener;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			if (performableActionListener.isActionPerformed(e))
				super.actionPerformed(e);
		} catch (Throwable throwable) {
			JOptionPaneException.show(getWindowAncestor(e.getSource()), throwable);
		}
	}
}