package util.swing.action.throwable;

import static util.swing.SwingUtilities.getWindowAncestor;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import util.swing.ActionDecorator;
import util.swing.dialog.JOptionPaneException;

@SuppressWarnings("serial")
public class ThrowableActionDecorator extends ActionDecorator {

	private final ThrowableActionListener throwableActionListener;

	public ThrowableActionDecorator(Action action, ThrowableActionListener throwableActionListener) {
		super(action);
		this.throwableActionListener = throwableActionListener;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			throwableActionListener.actionPerformed(e);
			super.actionPerformed(e);
		} catch (Throwable throwable) {
			JOptionPaneException.show(getWindowAncestor(e.getSource()), throwable);
		}
	}
}