package util.swing.algorithm.distance.minkowski;

import static com.jgoodies.validation.view.ValidationComponentUtils.setMessageKey;
import static util.LocaleUtil.GetString;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;
import static util.algorithm.distance.minkowski.Minkowski.KEY_POWER;
import static util.algorithm.distance.minkowski.Minkowski.LABEL_POWER;
import static util.algorithm.distance.minkowski.Minkowski.PROPERTY_POWER;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;

import util.swing.JFormattedTextFieldDouble;

import com.jgoodies.binding.adapter.Bindings;

@SuppressWarnings("serial")
public class JPanelMinkowski extends JPanel {

	private JLabel labelPower;
	private JFormattedTextFieldDouble fieldPower;

	public JPanelMinkowski() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getLabelPower(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getFieldPower(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(MinkowskiAdapter minkowskiAdapter) {
		Bindings.bind(getFieldPower(), minkowskiAdapter.getModel(PROPERTY_POWER));
	}

	private JLabel getLabelPower() {
		if (labelPower == null) {
			labelPower = new JLabel(GetString(LABEL_POWER));
		}
		return labelPower;
	}

	private JFormattedTextFieldDouble getFieldPower() {
		if (fieldPower == null) {
			fieldPower = new JFormattedTextFieldDouble();
			fieldPower.setColumns(5);
			setMessageKey(fieldPower, KEY_POWER);
		}
		return fieldPower;
	}
}
