package util.swing.dialog;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

@SuppressWarnings("serial")
// TODO a supprimer: utiliser JOptionPaneAction a la place
public class JButtonOptionPane extends JButton {

	public JButtonOptionPane() {
		super();
		initializeAction();
	}

	public JButtonOptionPane(Icon icon) {
		super(icon);
		initializeAction();
	}

	public JButtonOptionPane(String text) {
		super(text);
		initializeAction();
	}

	public JButtonOptionPane(Action a) {
		super(a);
		initializeAction();
	}

	public JButtonOptionPane(String text, Icon icon) {
		super(text, icon);
		initializeAction();
	}

	private void initializeAction() {
		this.setAction(new AbstractAction(getText(), getIcon()) {

			public void actionPerformed(ActionEvent e) {
				setOptionPaneValue();
			}});
	}
	
	public void setOptionPaneValue() {
		JOptionPane optionPane = (JOptionPane) SwingUtilities.getAncestorOfClass(JOptionPane.class, this);
		if(optionPane != null) 
			optionPane.setValue(this);
	}
}
