package util.swing.dialog;

import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

@SuppressWarnings("serial")
public class JOptionPaneAction extends AbstractAction {

	public JOptionPaneAction(String name) {
		super(name);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JOptionPane optionPane = (JOptionPane) SwingUtilities.getAncestorOfClass(JOptionPane.class, (Component) e.getSource());
		if(optionPane != null)
			optionPane.setValue(e.getSource());
	}

	public static Action createOkAction() {
		return new JOptionPaneAction(UIManager.getString("OptionPane.okButtonText"));
	}

	public static Action createCancelAction() {
		return new JOptionPaneAction(UIManager.getString("OptionPane.cancelButtonText"));
	}

	public static Action[] createOkCancelActions() {
		return new Action[] { createOkAction(), createCancelAction() };
	}
}
