package util.swing.dialog;

import static com.google.common.collect.Iterators.forArray;
import static com.google.common.collect.Iterators.toArray;
import static com.google.common.collect.Iterators.transform;

import javax.swing.Action;
import javax.swing.JButton;

import com.google.common.base.Function;

public class JOptionPaneOption {

	public static Object[] createOkCancelOptions() {
		return createOptions(JOptionPaneAction.createOkCancelActions());
	}

	public static Object[] createOptions(Action[] actions) {
		return toArray(transform(forArray(actions), new Function<Action, Object>() {

			@Override
			public Object apply(Action action) {
				return new JButton(action);
			}
		}), Object.class);
	}
}
