package util.swing.io;

import static com.jgoodies.binding.beans.PropertyConnector.connectAndUpdate;
import static java.awt.GridBagConstraints.EAST;
import static java.awt.GridBagConstraints.NONE;
import static java.awt.GridBagConstraints.RELATIVE;
import static java.awt.GridBagConstraints.REMAINDER;
import static java.awt.GridBagConstraints.WEST;
import static util.jgoodies.binding.value.FileConverterUtils.toNameConverter;
import static util.jgoodies.binding.value.FileConverterUtils.toPathConverter;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.value.ValueModel;

@SuppressWarnings("serial")
public class JPanelSaveAsFile extends JPanel {

	private JTextField fieldFileName;
	private JButton buttonSaveAs;

	public JPanelSaveAsFile() {
		initialize();
	}

	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		add(getFieldFileName(), new GridBagConstraints(0, RELATIVE, 1, 1, 0.0, 0.0, EAST, NONE, new Insets(0, 0, 0, 5), 0, 0));
		add(getButtonSaveAs(), new GridBagConstraints(RELATIVE, RELATIVE, REMAINDER, 1, 0.0, 0.0, WEST, NONE, new Insets(0, 0, 0, 0), 0, 0));
	}

	public void bind(ValueModel fileModel, Action saveAsAction) {
		Bindings.bind(getFieldFileName(), toNameConverter(fileModel));
		connectAndUpdate(toPathConverter(fileModel), getFieldFileName(), "toolTipText");
		getFieldFileName().setEditable(false);
		getFieldFileName().setFocusable(false);
		getButtonSaveAs().setAction(saveAsAction);
	}

	private JTextField getFieldFileName() {
		if (fieldFileName == null) {
			fieldFileName = new JTextField();
			fieldFileName.setColumns(25);
		}
		return fieldFileName;
	}

	private JButton getButtonSaveAs() {
		if (buttonSaveAs == null) {
			buttonSaveAs = new JButton();
		}
		return buttonSaveAs;
	}
}
