package util.swing.io;

import static util.LocaleUtil.GetString;
import static util.swing.SwingUtilities.getWindowAncestor;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;

import com.jgoodies.binding.value.ValueModel;

@SuppressWarnings("serial")
public class SaveAsAction extends AbstractAction {

	private final JFileChooser fileChooser;

	public SaveAsAction(ValueModel fileModel) {
		super(GetString("SaveAs"));
		this.fileChooser = getFileChooser(fileModel);
	}

	private static JFileChooser getFileChooser(final ValueModel fileModel) {
		JFileChooser fileChooser = new JFileChooser() {

			@Override
			public void approveSelection() {
				fileModel.setValue(getSelectedFile());
				super.approveSelection();
			} 
			
		};
		fileChooser.setSelectedFile((File) fileModel.getValue());
		return fileChooser;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		fileChooser.showSaveDialog(getWindowAncestor(e.getSource()));
	}
}
