package util.swing.text;

import static com.humaorie.dollar.Dollar.$;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;

import net.sf.jga.algorithms.Filter;
import net.sf.jga.fn.UnaryFunctor;

import org.apache.commons.lang.StringUtils;

public class DocumentFilter extends javax.swing.text.DocumentFilter {

	private final FilterFunctor filterFunctor;
	
	public DocumentFilter(FilterFunctor filterFunctor) {
		this.filterFunctor = filterFunctor;
	}
	
	private String filteredString(String string, int offset) {
		return StringUtils.join(Filter.filter($(string), filterFunctor).iterator(), null);
	}
	
	@Override
	public void insertString(FilterBypass fb, int offset, String string, AttributeSet attr) throws BadLocationException {
		super.insertString(fb, offset, filteredString(string, offset), attr);
	}

	@Override
	public void replace(FilterBypass fb, int offset, int length, String text, AttributeSet attrs) throws BadLocationException {
		super.replace(fb, offset, length, filteredString(text, offset), attrs);
	}
	
	@SuppressWarnings("serial")
	public static abstract class FilterFunctor extends UnaryFunctor<Character, Boolean> {}
}
